/*
 Copyright 2007 Politecnico di Milano
 This file is part of Dynamo.

 Dynamo is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3 of the License, or
 (at your option) any later version.

 Dynamo is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.polimi.WSCoL;
// $ANTLR : "WSCoL_2.g" -> "WSCoLLexer.java"$

import java.io.InputStream;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.TokenStreamRecognitionException;
import antlr.CharStreamException;
import antlr.CharStreamIOException;
import antlr.ANTLRException;
import java.io.Reader;
import java.util.Hashtable;
import antlr.antlrStudio.ASDebugCharScanner;
import antlr.InputBuffer;
import antlr.antlrStudio.DebuggingByteBuffer;
import antlr.antlrStudio.DebuggingCharBuffer;
import antlr.Token;
import antlr.CommonToken;
import antlr.RecognitionException;
import antlr.NoViableAltForCharException;
import antlr.MismatchedCharException;
import antlr.TokenStream;
import antlr.ANTLRHashString;
import antlr.antlrStudio.DebugLexerSharedInputState;
import antlr.LexerSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.SemanticException;

public class WSCoLLexer extends antlr.antlrStudio.ASDebugCharScanner implements WSCoLLexerTokenTypes, TokenStream
 {
public WSCoLLexer(InputStream in) {
	this(new DebuggingByteBuffer(in));
}
public WSCoLLexer(Reader in) {
	this(new antlr.antlrStudio.DebuggingCharBuffer(in));
}
public WSCoLLexer(InputBuffer ib) {
	this(new antlr.antlrStudio.DebugLexerSharedInputState(ib));
}
public WSCoLLexer(LexerSharedInputState state) {
	super(state);
	caseSensitiveLiterals = true;
	setCaseSensitive(true);
	literals = new Hashtable();
	literals.put(new ANTLRHashString("sum", this), new Integer(21));
	literals.put(new ANTLRHashString("min", this), new Integer(19));
	literals.put(new ANTLRHashString("retrieve", this), new Integer(16));
	literals.put(new ANTLRHashString("false", this), new Integer(10));
	literals.put(new ANTLRHashString("true", this), new Integer(9));
	literals.put(new ANTLRHashString("let", this), new Integer(14));
	literals.put(new ANTLRHashString("and", this), new Integer(8));
	literals.put(new ANTLRHashString("product", this), new Integer(22));
	literals.put(new ANTLRHashString("exists", this), new Integer(12));
	literals.put(new ANTLRHashString("avg", this), new Integer(20));
	literals.put(new ANTLRHashString("in", this), new Integer(13));
	literals.put(new ANTLRHashString("returnBool", this), new Integer(24));
	literals.put(new ANTLRHashString("Resp_Time", this), new Integer(17));
	literals.put(new ANTLRHashString("elseif", this), new Integer(6));
	literals.put(new ANTLRHashString("or", this), new Integer(7));
	literals.put(new ANTLRHashString("max", this), new Integer(18));
	literals.put(new ANTLRHashString("returnInt", this), new Integer(23));
	literals.put(new ANTLRHashString("store", this), new Integer(15));
	literals.put(new ANTLRHashString("if", this), new Integer(4));
	literals.put(new ANTLRHashString("forall", this), new Integer(11));
	literals.put(new ANTLRHashString("else", this), new Integer(5));
	literals.put(new ANTLRHashString("returnString", this), new Integer(25));
}

public Token nextToken() throws TokenStreamException {
	Token theRetToken=null;
tryAgain:
	for (;;) {
		Token _token = null;
		int _ttype = Token.INVALID_TYPE;
		resetText();
		try {   // for char stream error handling
			try {   // for lexical error handling
				switch ( LA(1)) {
				case '"':  case '\'':
				{
					mLITERAL(true);
					theRetToken=_returnToken;
					break;
				}
				case '0':  case '1':  case '2':  case '3':
				case '4':  case '5':  case '6':  case '7':
				case '8':  case '9':
				{
					mNUMBER(true);
					theRetToken=_returnToken;
					break;
				}
				case 'A':  case 'B':  case 'C':  case 'D':
				case 'E':  case 'F':  case 'G':  case 'H':
				case 'I':  case 'J':  case 'K':  case 'L':
				case 'M':  case 'N':  case 'O':  case 'P':
				case 'Q':  case 'R':  case 'S':  case 'T':
				case 'U':  case 'V':  case 'W':  case 'X':
				case 'Y':  case 'Z':  case '_':  case 'a':
				case 'b':  case 'c':  case 'd':  case 'e':
				case 'f':  case 'g':  case 'h':  case 'i':
				case 'j':  case 'k':  case 'l':  case 'm':
				case 'n':  case 'o':  case 'p':  case 'q':
				case 'r':  case 's':  case 't':  case 'u':
				case 'v':  case 'w':  case 'x':  case 'y':
				case 'z':
				{
					mIDENTIFIER(true);
					theRetToken=_returnToken;
					break;
				}
				case ';':
				{
					mSEMI(true);
					theRetToken=_returnToken;
					break;
				}
				case '(':
				{
					mLEFT_PAREN(true);
					theRetToken=_returnToken;
					break;
				}
				case ')':
				{
					mRIGHT_PAREN(true);
					theRetToken=_returnToken;
					break;
				}
				case '[':
				{
					mLEFT_BRACKET(true);
					theRetToken=_returnToken;
					break;
				}
				case ']':
				{
					mRIGHT_BRACKET(true);
					theRetToken=_returnToken;
					break;
				}
				case '{':
				{
					mLEFT_CURLY(true);
					theRetToken=_returnToken;
					break;
				}
				case '}':
				{
					mRIGHT_CURLY(true);
					theRetToken=_returnToken;
					break;
				}
				case '@':
				{
					mAT(true);
					theRetToken=_returnToken;
					break;
				}
				case ',':
				{
					mCOMMA(true);
					theRetToken=_returnToken;
					break;
				}
				case '$':
				{
					mDOLLAR_SIGN(true);
					theRetToken=_returnToken;
					break;
				}
				case '+':
				{
					mPLUS(true);
					theRetToken=_returnToken;
					break;
				}
				case '-':
				{
					mMINUS(true);
					theRetToken=_returnToken;
					break;
				}
				case '%':
				{
					mPERCENTAGE(true);
					theRetToken=_returnToken;
					break;
				}
				case '*':
				{
					mSTAR(true);
					theRetToken=_returnToken;
					break;
				}
				case '&':
				{
					mAND(true);
					theRetToken=_returnToken;
					break;
				}
				default:
					if ((LA(1)=='<') && (LA(2)=='=') && (LA(3)=='=') && (LA(4)=='>')) {
						mKW_2WIMPLIES(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='=') && (LA(2)=='=') && (LA(3)=='>')) {
						mKW_LR_IMPLIES(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='<') && (LA(2)=='=') && (LA(3)=='=') && (true)) {
						mKW_RL_IMPLIES(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='.') && (LA(2)=='.')) {
						mDOT_DOT(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)==':') && (LA(2)==':')) {
						mDOUBLE_COLON(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='/') && (LA(2)=='/')) {
						mDOUBLE_SLASH(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='=') && (LA(2)=='=') && (true)) {
						mDOUBLE_EQUALS(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='!') && (LA(2)=='=')) {
						mNOT_EQUALS(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='<') && (LA(2)=='=') && (true)) {
						mLTE(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='>') && (LA(2)=='=')) {
						mGTE(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='|') && (LA(2)=='|')) {
						mOR(true);
						theRetToken=_returnToken;
					}
					else if ((_tokenSet_0.member(LA(1))) && (true) && (true) && (true)) {
						mWS(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='|') && (true)) {
						mPIPE(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='.') && (true)) {
						mDOT(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)==':') && (true)) {
						mCOLON(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='/') && (true)) {
						mSLASH(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='=') && (true)) {
						mEQUALS(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='<') && (true)) {
						mLT(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='>') && (true)) {
						mGT(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='!') && (true)) {
						mNOT(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='\n'||LA(1)=='\r') && (true) && (true) && (true)) {
						mNEWLINE(true);
						theRetToken=_returnToken;
					}
				else {
					if (LA(1)==EOF_CHAR) {uponEOF(); _returnToken = makeToken(Token.EOF_TYPE);}
				else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
				}
				}
				if ( _returnToken==null ) continue tryAgain; // found SKIP token
				_ttype = _returnToken.getType();
				_ttype = testLiteralsTable(_ttype);
				_returnToken.setType(_ttype);
				return _returnToken;
			}
			catch (RecognitionException e) {
				throw new TokenStreamRecognitionException(e);
			}
		}
		catch (CharStreamException cse) {
			if ( cse instanceof CharStreamIOException ) {
				throw new TokenStreamIOException(((CharStreamIOException)cse).io);
			}
			else {
				throw new TokenStreamException(cse.getMessage());
			}
		}
	}
}

	public final void mWS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = WS;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			{
			int _cnt878=0;
			_loop878:
			do {
				switch ( LA(1)) {
				case '\n':
				{
					bShouldFire=aboutToEnter(bShouldFire,"WS",1,330);
					match('\n');
					break;
				}
				case ' ':
				{
					bShouldFire=aboutToEnter(bShouldFire,"WS",2,336);
					match(' ');
					break;
				}
				case '\t':
				{
					bShouldFire=aboutToEnter(bShouldFire,"WS",3,342);
					match('\t');
					break;
				}
				case '\r':
				{
					bShouldFire=aboutToEnter(bShouldFire,"WS",4,348);
					match('\r');
					break;
				}
				default:
				{
					if ( _cnt878>=1 ) { break _loop878; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
				}
				}
				_cnt878++;
			} while (true);
			}
			
						_ttype = Token.SKIP;
					
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	protected final void mDIGIT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DIGIT;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			{
			bShouldFire=aboutToEnter(bShouldFire,"DIGIT",1,383);
			matchRange('0','9');
			}
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	protected final void mSINGLE_QUOTE_STRING(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = SINGLE_QUOTE_STRING;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			_saveIndex=text.length();
			bShouldFire=aboutToEnter(bShouldFire,"SINGLE_QUOTE_STRING",1,406);
			match('\'');
			text.setLength(_saveIndex);
			{
			_loop884:
			do {
				if ((_tokenSet_1.member(LA(1)))) {
					{
					match(_tokenSet_1);
					}
				}
				else {
					break _loop884;
				}
				
			} while (true);
			}
			_saveIndex=text.length();
			bShouldFire=aboutToEnter(bShouldFire,"SINGLE_QUOTE_STRING",2,424);
			match('\'');
			text.setLength(_saveIndex);
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	protected final void mDOUBLE_QUOTE_STRING(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DOUBLE_QUOTE_STRING;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			_saveIndex=text.length();
			bShouldFire=aboutToEnter(bShouldFire,"DOUBLE_QUOTE_STRING",1,447);
			match('"');
			text.setLength(_saveIndex);
			{
			_loop888:
			do {
				if ((_tokenSet_2.member(LA(1)))) {
					{
					match(_tokenSet_2);
					}
				}
				else {
					break _loop888;
				}
				
			} while (true);
			}
			_saveIndex=text.length();
			bShouldFire=aboutToEnter(bShouldFire,"DOUBLE_QUOTE_STRING",2,465);
			match('"');
			text.setLength(_saveIndex);
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mLITERAL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = LITERAL;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			switch ( LA(1)) {
			case '\'':
			{
				bShouldFire=aboutToEnter(bShouldFire,"LITERAL",1,490);
				mSINGLE_QUOTE_STRING(false);
				break;
			}
			case '"':
			{
				bShouldFire=aboutToEnter(bShouldFire,"LITERAL",2,496);
				mDOUBLE_QUOTE_STRING(false);
				break;
			}
			default:
			{
				throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mNUMBER(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = NUMBER;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			{
			int _cnt892=0;
			_loop892:
			do {
				if (((LA(1) >= '0' && LA(1) <= '9'))) {
					bShouldFire=aboutToEnter(bShouldFire,"NUMBER",1,529);
					mDIGIT(false);
				}
				else {
					if ( _cnt892>=1 ) { break _loop892; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
				}
				
				_cnt892++;
			} while (true);
			}
			{
			if ((LA(1)=='.')) {
				bShouldFire=aboutToEnter(bShouldFire,"NUMBER",2,541);
				match('.');
				{
				int _cnt895=0;
				_loop895:
				do {
					if (((LA(1) >= '0' && LA(1) <= '9'))) {
						bShouldFire=aboutToEnter(bShouldFire,"NUMBER",3,548);
						mDIGIT(false);
					}
					else {
						if ( _cnt895>=1 ) { break _loop895; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
					}
					
					_cnt895++;
				} while (true);
				}
			}
			else {
			}
			
			}
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mIDENTIFIER(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = IDENTIFIER;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			{
			switch ( LA(1)) {
			case 'a':  case 'b':  case 'c':  case 'd':
			case 'e':  case 'f':  case 'g':  case 'h':
			case 'i':  case 'j':  case 'k':  case 'l':
			case 'm':  case 'n':  case 'o':  case 'p':
			case 'q':  case 'r':  case 's':  case 't':
			case 'u':  case 'v':  case 'w':  case 'x':
			case 'y':  case 'z':
			{
				bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",1,592);
				matchRange('a','z');
				break;
			}
			case 'A':  case 'B':  case 'C':  case 'D':
			case 'E':  case 'F':  case 'G':  case 'H':
			case 'I':  case 'J':  case 'K':  case 'L':
			case 'M':  case 'N':  case 'O':  case 'P':
			case 'Q':  case 'R':  case 'S':  case 'T':
			case 'U':  case 'V':  case 'W':  case 'X':
			case 'Y':  case 'Z':
			{
				bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",2,604);
				matchRange('A','Z');
				break;
			}
			case '_':
			{
				bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",3,610);
				match('_');
				break;
			}
			default:
			{
				throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			{
			_loop899:
			do {
				switch ( LA(1)) {
				case 'a':  case 'b':  case 'c':  case 'd':
				case 'e':  case 'f':  case 'g':  case 'h':
				case 'i':  case 'j':  case 'k':  case 'l':
				case 'm':  case 'n':  case 'o':  case 'p':
				case 'q':  case 'r':  case 's':  case 't':
				case 'u':  case 'v':  case 'w':  case 'x':
				case 'y':  case 'z':
				{
					bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",4,632);
					matchRange('a','z');
					break;
				}
				case 'A':  case 'B':  case 'C':  case 'D':
				case 'E':  case 'F':  case 'G':  case 'H':
				case 'I':  case 'J':  case 'K':  case 'L':
				case 'M':  case 'N':  case 'O':  case 'P':
				case 'Q':  case 'R':  case 'S':  case 'T':
				case 'U':  case 'V':  case 'W':  case 'X':
				case 'Y':  case 'Z':
				{
					bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",5,644);
					matchRange('A','Z');
					break;
				}
				case '-':
				{
					bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",6,650);
					match('-');
					break;
				}
				case '_':
				{
					bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",7,656);
					match('_');
					break;
				}
				case '0':  case '1':  case '2':  case '3':
				case '4':  case '5':  case '6':  case '7':
				case '8':  case '9':
				{
					bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",8,664);
					matchRange('0','9');
					break;
				}
				case '.':
				{
					bShouldFire=aboutToEnter(bShouldFire,"IDENTIFIER",9,670);
					match('.');
					break;
				}
				default:
				{
					break _loop899;
				}
				}
			} while (true);
			}
			_ttype = testLiteralsTable(_ttype);
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mSEMI(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = SEMI;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"SEMI",1,701);
			match(';');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mLEFT_PAREN(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = LEFT_PAREN;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"LEFT_PAREN",1,722);
			match('(');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mRIGHT_PAREN(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = RIGHT_PAREN;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"RIGHT_PAREN",1,743);
			match(')');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mLEFT_BRACKET(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = LEFT_BRACKET;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"LEFT_BRACKET",1,764);
			match('[');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mRIGHT_BRACKET(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = RIGHT_BRACKET;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"RIGHT_BRACKET",1,785);
			match(']');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mLEFT_CURLY(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = LEFT_CURLY;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"LEFT_CURLY",1,806);
			match('{');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mRIGHT_CURLY(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = RIGHT_CURLY;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"RIGHT_CURLY",1,827);
			match('}');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mPIPE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = PIPE;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"PIPE",1,848);
			match('|');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mDOT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DOT;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"DOT",1,869);
			match('.');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mDOT_DOT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DOT_DOT;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"DOT_DOT",1,890);
			match("..");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mAT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = AT;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"AT",1,911);
			match('@');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mCOMMA(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = COMMA;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"COMMA",1,932);
			match(',');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mDOUBLE_COLON(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DOUBLE_COLON;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"DOUBLE_COLON",1,953);
			match("::");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mCOLON(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = COLON;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"COLON",1,974);
			match(":");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mSLASH(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = SLASH;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"SLASH",1,995);
			match('/');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mDOUBLE_SLASH(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DOUBLE_SLASH;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"DOUBLE_SLASH",1,1016);
			match('/');
			bShouldFire=aboutToEnter(bShouldFire,"DOUBLE_SLASH",2,1018);
			match('/');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mDOLLAR_SIGN(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DOLLAR_SIGN;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"DOLLAR_SIGN",1,1039);
			match('$');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mPLUS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = PLUS;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"PLUS",1,1060);
			match('+');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mMINUS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = MINUS;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"MINUS",1,1081);
			match('-');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mPERCENTAGE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = PERCENTAGE;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"PERCENTAGE",1,1102);
			match('%');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mDOUBLE_EQUALS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DOUBLE_EQUALS;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"DOUBLE_EQUALS",1,1123);
			match("==");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mEQUALS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = EQUALS;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"EQUALS",1,1144);
			match('=');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mNOT_EQUALS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = NOT_EQUALS;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"NOT_EQUALS",1,1165);
			match("!=");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mLT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = LT;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"LT",1,1186);
			match('<');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mLTE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = LTE;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"LTE",1,1207);
			match("<=");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mGT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = GT;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"GT",1,1228);
			match('>');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mGTE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = GTE;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"GTE",1,1249);
			match(">=");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mSTAR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = STAR;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"STAR",1,1270);
			match('*');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mAND(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = AND;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"AND",1,1291);
			match("&&");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mOR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = OR;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"OR",1,1312);
			match("||");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mNOT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = NOT;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"NOT",1,1333);
			match('!');
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mKW_LR_IMPLIES(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = KW_LR_IMPLIES;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"KW_LR_IMPLIES",1,1354);
			match("==>");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mKW_RL_IMPLIES(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = KW_RL_IMPLIES;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"KW_RL_IMPLIES",1,1375);
			match("<==");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mKW_2WIMPLIES(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = KW_2WIMPLIES;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			bShouldFire=aboutToEnter(bShouldFire,"KW_2WIMPLIES",1,1396);
			match("<==>");
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	public final void mNEWLINE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = NEWLINE;
		int _saveIndex;
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		try { // debugging
			
			{
			if ((LA(1)=='\r') && (LA(2)=='\n')) {
				bShouldFire=aboutToEnter(bShouldFire,"NEWLINE",1,1419);
				match("\r\n");
			}
			else if ((LA(1)=='\r') && (true)) {
				bShouldFire=aboutToEnter(bShouldFire,"NEWLINE",2,1423);
				match('\r');
			}
			else if ((LA(1)=='\n')) {
				bShouldFire=aboutToEnter(bShouldFire,"NEWLINE",3,1427);
				match('\n');
			}
			else {
				throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			
			}
			newline();
				  _ttype = Token.SKIP;
				
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		} finally { // debugging
		}
	}
	
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 4294977024L, 0L, 0L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = new long[8];
		data[0]=-549755813896L;
		for (int i = 1; i<=3; i++) { data[i]=-1L; }
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = new long[8];
		data[0]=-17179869192L;
		for (int i = 1; i<=3; i++) { data[i]=-1L; }
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	
	}
