/*
 Copyright 2007 Politecnico di Milano
 This file is part of Dynamo.

 Dynamo is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3 of the License, or
 (at your option) any later version.

 Dynamo is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.polimi.WSCoL;
// $ANTLR : "WSCoL_2.g" -> "WSCoLLexer.java"$

public interface WSCoLLexerTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int KW_IF = 4;
	int KW_ELSE = 5;
	int KW_ELSEIF = 6;
	int KW_OR = 7;
	int KW_AND = 8;
	int KW_TRUE = 9;
	int KW_FALSE = 10;
	int KW_FORALL = 11;
	int KW_EXISTS = 12;
	int KW_IN = 13;
	int KW_LET = 14;
	int KW_STORE = 15;
	int KW_RETRIEVE = 16;
	int KW_RESP_TIME = 17;
	int KW_MAX = 18;
	int KW_MIN = 19;
	int KW_AVG = 20;
	int KW_SUM = 21;
	int KW_PRODUCT = 22;
	int KW_RETURN_NUMBER = 23;
	int KW_RETURN_BOOL = 24;
	int KW_RETURN_STRING = 25;
	int WS = 26;
	int DIGIT = 27;
	int SINGLE_QUOTE_STRING = 28;
	int DOUBLE_QUOTE_STRING = 29;
	int LITERAL = 30;
	int NUMBER = 31;
	int IDENTIFIER = 32;
	int SEMI = 33;
	int LEFT_PAREN = 34;
	int RIGHT_PAREN = 35;
	int LEFT_BRACKET = 36;
	int RIGHT_BRACKET = 37;
	int LEFT_CURLY = 38;
	int RIGHT_CURLY = 39;
	int PIPE = 40;
	int DOT = 41;
	int DOT_DOT = 42;
	int AT = 43;
	int COMMA = 44;
	int DOUBLE_COLON = 45;
	int COLON = 46;
	int SLASH = 47;
	int DOUBLE_SLASH = 48;
	int DOLLAR_SIGN = 49;
	int PLUS = 50;
	int MINUS = 51;
	int PERCENTAGE = 52;
	int DOUBLE_EQUALS = 53;
	int EQUALS = 54;
	int NOT_EQUALS = 55;
	int LT = 56;
	int LTE = 57;
	int GT = 58;
	int GTE = 59;
	int STAR = 60;
	int AND = 61;
	int OR = 62;
	int NOT = 63;
	int KW_LR_IMPLIES = 64;
	int KW_RL_IMPLIES = 65;
	int KW_2WIMPLIES = 66;
	int NEWLINE = 67;
	int RECOVERY = 68;
	int CONDITION = 69;
	int COMPLETE = 70;
	int STRATEGY = 71;
	int IF = 72;
	int ELSEIF = 73;
	int ELSE = 74;
	int ACTION = 75;
	int STEP = 76;
	int RULES = 77;
	int EXTERNAL_VARIABLE = 78;
	int INTERNAL_VARIABLE = 79;
	int PARAM_LIST = 80;
	int METHOD = 81;
	int FORALL = 82;
	int EXISTS = 83;
	int SERIES = 84;
	int CONCAT = 85;
	int WSDL = 86;
	int WM = 87;
	int INPUTS = 88;
	int OUTPUTS = 89;
	int XPATH = 90;
	int VAR = 91;
	int LET = 92;
	int STORE = 93;
	int RETRIEVE = 94;
	int MAX = 95;
	int MIN = 96;
	int AVG = 97;
	int SUM = 98;
	int PRODUCT = 99;
	int RETURN_NUMBER = 100;
	int RETURN_BOOL = 101;
	int RETURN_STRING = 102;
	int ALIAS = 103;
	int ALIAS_NAME = 104;
	int PROCESS_ID = 105;
	int USER_ID = 106;
	int INSTANCE_ID = 107;
	int LOCATION = 108;
	int ASSERTION_TYPE = 109;
	int HISTORICAL_VARIABLE = 110;
	int NUMBER_OF_RESULTS = 111;
	int DIV = 112;
	int MOD = 113;
}
