/*
 Copyright 2007 Politecnico di Milano
 This file is part of Dynamo.

 Dynamo is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3 of the License, or
 (at your option) any later version.

 Dynamo is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.polimi.WSCoL;
// $ANTLR : "WSCoL_2.g" -> "WSCoLParser.java"$

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.antlrStudio.ASLLKDebuggingParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class WSCoLParser extends antlr.antlrStudio.ASLLKDebuggingParser       implements WSCoLLexerTokenTypes
 {
	//simboli
	class Symbol {
        String name;
        public Symbol(String name) {
            this.name = name;
        }
    }
	//creo la tabella dei symboli
	java.util.Hashtable<String,Symbol> symbols = new java.util.Hashtable<String,Symbol>();

protected WSCoLParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public WSCoLParser(TokenBuffer tokenBuf) {
  this(tokenBuf,4);
}

protected WSCoLParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public WSCoLParser(TokenStream lexer) {
  this(lexer,4);
}

public WSCoLParser(ParserSharedInputState state) {
  super(state,4);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void imaginaryTokenDefinitions() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("imaginaryTokenDefinitions");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST imaginaryTokenDefinitions_AST = null;
			
			try {      // for error handling
				AST tmp1_AST = null;
				tmp1_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp1_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",1,80);
				match(RECOVERY);
				AST tmp2_AST = null;
				tmp2_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp2_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",2,85);
				match(CONDITION);
				AST tmp3_AST = null;
				tmp3_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp3_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",3,90);
				match(COMPLETE);
				AST tmp4_AST = null;
				tmp4_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp4_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",4,95);
				match(STRATEGY);
				AST tmp5_AST = null;
				tmp5_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp5_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",5,100);
				match(IF);
				AST tmp6_AST = null;
				tmp6_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp6_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",6,105);
				match(ELSEIF);
				AST tmp7_AST = null;
				tmp7_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp7_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",7,110);
				match(ELSE);
				AST tmp8_AST = null;
				tmp8_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp8_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",8,115);
				match(ACTION);
				AST tmp9_AST = null;
				tmp9_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp9_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",9,120);
				match(STEP);
				AST tmp10_AST = null;
				tmp10_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp10_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",10,125);
				match(RULES);
				AST tmp11_AST = null;
				tmp11_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp11_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",11,130);
				match(EXTERNAL_VARIABLE);
				AST tmp12_AST = null;
				tmp12_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp12_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",12,135);
				match(INTERNAL_VARIABLE);
				AST tmp13_AST = null;
				tmp13_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp13_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",13,140);
				match(PARAM_LIST);
				AST tmp14_AST = null;
				tmp14_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp14_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",14,145);
				match(METHOD);
				AST tmp15_AST = null;
				tmp15_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp15_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",15,150);
				match(FORALL);
				AST tmp16_AST = null;
				tmp16_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp16_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",16,155);
				match(EXISTS);
				AST tmp17_AST = null;
				tmp17_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp17_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",17,160);
				match(SERIES);
				AST tmp18_AST = null;
				tmp18_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp18_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",18,165);
				match(CONCAT);
				it.polimi.monitor.nodes.SimpleAST tmp19_AST = null;
				tmp19_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(LT(1),"it.polimi.monitor.nodes.SimpleAST");
				astFactory.addASTChild(currentAST, tmp19_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",19,170);
				match(WSDL);
				it.polimi.monitor.nodes.SimpleAST tmp20_AST = null;
				tmp20_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(LT(1),"it.polimi.monitor.nodes.SimpleAST");
				astFactory.addASTChild(currentAST, tmp20_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",20,175);
				match(WM);
				it.polimi.monitor.nodes.SimpleAST tmp21_AST = null;
				tmp21_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(LT(1),"it.polimi.monitor.nodes.SimpleAST");
				astFactory.addASTChild(currentAST, tmp21_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",21,180);
				match(INPUTS);
				AST tmp22_AST = null;
				tmp22_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp22_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",22,185);
				match(OUTPUTS);
				AST tmp23_AST = null;
				tmp23_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp23_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",23,190);
				match(XPATH);
				AST tmp24_AST = null;
				tmp24_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp24_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",24,195);
				match(VAR);
				AST tmp25_AST = null;
				tmp25_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp25_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",25,200);
				match(LET);
				AST tmp26_AST = null;
				tmp26_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp26_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",26,205);
				match(STORE);
				AST tmp27_AST = null;
				tmp27_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp27_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",27,210);
				match(RETRIEVE);
				AST tmp28_AST = null;
				tmp28_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp28_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",28,215);
				match(MAX);
				AST tmp29_AST = null;
				tmp29_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp29_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",29,220);
				match(MIN);
				AST tmp30_AST = null;
				tmp30_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp30_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",30,225);
				match(AVG);
				AST tmp31_AST = null;
				tmp31_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp31_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",31,230);
				match(SUM);
				AST tmp32_AST = null;
				tmp32_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp32_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",32,235);
				match(PRODUCT);
				AST tmp33_AST = null;
				tmp33_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp33_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",33,240);
				match(RETURN_NUMBER);
				AST tmp34_AST = null;
				tmp34_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp34_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",34,245);
				match(RETURN_BOOL);
				AST tmp35_AST = null;
				tmp35_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp35_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",35,250);
				match(RETURN_STRING);
				AST tmp36_AST = null;
				tmp36_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp36_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",36,255);
				match(ALIAS);
				AST tmp37_AST = null;
				tmp37_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp37_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",37,260);
				match(ALIAS_NAME);
				AST tmp38_AST = null;
				tmp38_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp38_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",38,265);
				match(PROCESS_ID);
				AST tmp39_AST = null;
				tmp39_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp39_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",39,270);
				match(USER_ID);
				AST tmp40_AST = null;
				tmp40_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp40_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",40,275);
				match(INSTANCE_ID);
				AST tmp41_AST = null;
				tmp41_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp41_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",41,280);
				match(LOCATION);
				AST tmp42_AST = null;
				tmp42_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp42_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",42,285);
				match(ASSERTION_TYPE);
				AST tmp43_AST = null;
				tmp43_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp43_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",43,290);
				match(HISTORICAL_VARIABLE);
				AST tmp44_AST = null;
				tmp44_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp44_AST);
				bShouldFire=aboutToEnter(bShouldFire,"imaginaryTokenDefinitions",44,295);
				match(NUMBER_OF_RESULTS);
				imaginaryTokenDefinitions_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = imaginaryTokenDefinitions_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void analyzer() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("analyzer");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST analyzer_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case KW_TRUE:
				case KW_FALSE:
				case KW_LET:
				case KW_STORE:
				case KW_RETRIEVE:
				case KW_RESP_TIME:
				case KW_RETURN_NUMBER:
				case KW_RETURN_BOOL:
				case KW_RETURN_STRING:
				case LITERAL:
				case NUMBER:
				case IDENTIFIER:
				case LEFT_PAREN:
				case DOLLAR_SIGN:
				{
					bShouldFire=aboutToEnter(bShouldFire,"analyzer",1,342);
					rules();
					astFactory.addASTChild(currentAST, returnAST);
					analyzer_AST = (AST)currentAST.root;
					break;
				}
				case KW_IF:
				case LEFT_CURLY:
				{
					bShouldFire=aboutToEnter(bShouldFire,"analyzer",2,351);
					recovery();
					astFactory.addASTChild(currentAST, returnAST);
					analyzer_AST = (AST)currentAST.root;
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = analyzer_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void rules() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("rules");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST rules_AST = null;
			
			try {      // for error handling
				{
				int _cnt959=0;
				_loop959:
				do {
					if ((_tokenSet_1.member(LA(1)))) {
						bShouldFire=aboutToEnter(bShouldFire,"rules",1,395);
						rule();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						if ( _cnt959>=1 ) { break _loop959; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt959++;
				} while (true);
				}
				if ( inputState.guessing==0 ) {
					rules_AST = (AST)currentAST.root;
					rules_AST =(AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(RULES,"Rules")).add(rules_AST));
					currentAST.root = rules_AST;
					currentAST.child = rules_AST!=null &&rules_AST.getFirstChild()!=null ?
						rules_AST.getFirstChild() : rules_AST;
					currentAST.advanceChildToEnd();
				}
				rules_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_2);
				} else {
				  throw ex;
				}
			}
			returnAST = rules_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void recovery() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("recovery");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST recovery_AST = null;
			AST cs_AST = null;
			AST s_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case KW_IF:
				{
					bShouldFire=aboutToEnter(bShouldFire,"recovery",1,448);
					complete_strategy();
					cs_AST = (AST)returnAST;
					if ( inputState.guessing==0 ) {
						recovery_AST = (AST)currentAST.root;
						
										recovery_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(RECOVERY,"Recovery")).add(cs_AST));
									
						currentAST.root = recovery_AST;
						currentAST.child = recovery_AST!=null &&recovery_AST.getFirstChild()!=null ?
							recovery_AST.getFirstChild() : recovery_AST;
						currentAST.advanceChildToEnd();
					}
					break;
				}
				case LEFT_CURLY:
				{
					bShouldFire=aboutToEnter(bShouldFire,"recovery",2,465);
					strategy();
					s_AST = (AST)returnAST;
					if ( inputState.guessing==0 ) {
						recovery_AST = (AST)currentAST.root;
						
										recovery_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(RECOVERY,"Recovery")).add(s_AST));
									
						currentAST.root = recovery_AST;
						currentAST.child = recovery_AST!=null &&recovery_AST.getFirstChild()!=null ?
							recovery_AST.getFirstChild() : recovery_AST;
						currentAST.advanceChildToEnd();
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = recovery_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void complete_strategy() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("complete_strategy");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST complete_strategy_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"complete_strategy",1,513);
				ifStrategy();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop941:
				do {
					if ((LA(1)==KW_ELSEIF)) {
						bShouldFire=aboutToEnter(bShouldFire,"complete_strategy",2,520);
						elseIfStrategy();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop941;
					}
					
				} while (true);
				}
				{
				switch ( LA(1)) {
				case KW_ELSE:
				{
					bShouldFire=aboutToEnter(bShouldFire,"complete_strategy",3,534);
					elseStrategy();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case EOF:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				complete_strategy_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = complete_strategy_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void strategy() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("strategy");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST strategy_AST = null;
			AST s_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"strategy",1,579);
				match(LEFT_CURLY);
				bShouldFire=aboutToEnter(bShouldFire,"strategy",2,581);
				steps();
				s_AST = (AST)returnAST;
				bShouldFire=aboutToEnter(bShouldFire,"strategy",3,584);
				match(RIGHT_CURLY);
				if ( inputState.guessing==0 ) {
					strategy_AST = (AST)currentAST.root;
					
							strategy_AST = (AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(STRATEGY,"Strategy","it.polimi.recovery.nodes.StrategyNode")).add(s_AST)); 
						
					currentAST.root = strategy_AST;
					currentAST.child = strategy_AST!=null &&strategy_AST.getFirstChild()!=null ?
						strategy_AST.getFirstChild() : strategy_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_3);
				} else {
				  throw ex;
				}
			}
			returnAST = strategy_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void ifStrategy() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("ifStrategy");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST ifStrategy_AST = null;
			AST c_AST = null;
			AST s_AST = null;
			
			try {      // for error handling
				AST tmp47_AST = null;
				tmp47_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"ifStrategy",1,628);
				match(KW_IF);
				bShouldFire=aboutToEnter(bShouldFire,"ifStrategy",2,630);
				condition();
				c_AST = (AST)returnAST;
				bShouldFire=aboutToEnter(bShouldFire,"ifStrategy",3,633);
				strategy();
				s_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					ifStrategy_AST = (AST)currentAST.root;
					
								ifStrategy_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(IF,"If","it.polimi.recovery.nodes.IfStamentNode")).add(c_AST).add(s_AST));
							
					currentAST.root = ifStrategy_AST;
					currentAST.child = ifStrategy_AST!=null &&ifStrategy_AST.getFirstChild()!=null ?
						ifStrategy_AST.getFirstChild() : ifStrategy_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_3);
				} else {
				  throw ex;
				}
			}
			returnAST = ifStrategy_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void elseIfStrategy() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("elseIfStrategy");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST elseIfStrategy_AST = null;
			AST c_AST = null;
			AST s_AST = null;
			
			try {      // for error handling
				AST tmp48_AST = null;
				tmp48_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"elseIfStrategy",1,678);
				match(KW_ELSEIF);
				bShouldFire=aboutToEnter(bShouldFire,"elseIfStrategy",2,680);
				condition();
				c_AST = (AST)returnAST;
				bShouldFire=aboutToEnter(bShouldFire,"elseIfStrategy",3,683);
				strategy();
				s_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					elseIfStrategy_AST = (AST)currentAST.root;
					
								elseIfStrategy_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(ELSEIF,"ElseIf","it.polimi.recovery.nodes.IfStamentNode")).add(c_AST).add(s_AST));
							
					currentAST.root = elseIfStrategy_AST;
					currentAST.child = elseIfStrategy_AST!=null &&elseIfStrategy_AST.getFirstChild()!=null ?
						elseIfStrategy_AST.getFirstChild() : elseIfStrategy_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_3);
				} else {
				  throw ex;
				}
			}
			returnAST = elseIfStrategy_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void elseStrategy() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("elseStrategy");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST elseStrategy_AST = null;
			AST s_AST = null;
			
			try {      // for error handling
				AST tmp49_AST = null;
				tmp49_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp49_AST);
				bShouldFire=aboutToEnter(bShouldFire,"elseStrategy",1,728);
				match(KW_ELSE);
				bShouldFire=aboutToEnter(bShouldFire,"elseStrategy",2,730);
				strategy();
				s_AST = (AST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				if ( inputState.guessing==0 ) {
					elseStrategy_AST = (AST)currentAST.root;
					
								elseStrategy_AST = (AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(ELSE,"Else","it.polimi.recovery.nodes.IfStamentNode")).add(s_AST));
							
					currentAST.root = elseStrategy_AST;
					currentAST.child = elseStrategy_AST!=null &&elseStrategy_AST.getFirstChild()!=null ?
						elseStrategy_AST.getFirstChild() : elseStrategy_AST;
					currentAST.advanceChildToEnd();
				}
				elseStrategy_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = elseStrategy_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void condition() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("condition");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST condition_AST = null;
			AST r_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"condition",1,774);
				match(LEFT_PAREN);
				bShouldFire=aboutToEnter(bShouldFire,"condition",2,776);
				rules();
				r_AST = (AST)returnAST;
				bShouldFire=aboutToEnter(bShouldFire,"condition",3,779);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					condition_AST = (AST)currentAST.root;
					
							condition_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(CONDITION,"Condition")).add(r_AST)); 
							
					currentAST.root = condition_AST;
					currentAST.child = condition_AST!=null &&condition_AST.getFirstChild()!=null ?
						condition_AST.getFirstChild() : condition_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_4);
				} else {
				  throw ex;
				}
			}
			returnAST = condition_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void steps() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("steps");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST steps_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"steps",1,819);
				rec_step();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop950:
				do {
					if ((LA(1)==KW_OR)) {
						it.polimi.recovery.nodes.OrNode tmp52_AST = null;
						tmp52_AST = (it.polimi.recovery.nodes.OrNode)astFactory.create(LT(1),"it.polimi.recovery.nodes.OrNode");
						astFactory.makeASTRoot(currentAST, tmp52_AST);
						bShouldFire=aboutToEnter(bShouldFire,"steps",2,829);
						match(KW_OR);
						bShouldFire=aboutToEnter(bShouldFire,"steps",3,831);
						rec_step();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop950;
					}
					
				} while (true);
				}
				steps_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_5);
				} else {
				  throw ex;
				}
			}
			returnAST = steps_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void rec_step() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("rec_step");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST rec_step_AST = null;
			AST a_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"rec_step",1,871);
				actions();
				a_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					rec_step_AST = (AST)currentAST.root;
					
							rec_step_AST = (AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(STEP,"RecoveryStep","it.polimi.recovery.nodes.RecoveryStepNode")).add(a_AST));
						
					currentAST.root = rec_step_AST;
					currentAST.child = rec_step_AST!=null &&rec_step_AST.getFirstChild()!=null ?
						rec_step_AST.getFirstChild() : rec_step_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_6);
				} else {
				  throw ex;
				}
			}
			returnAST = rec_step_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void actions() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("actions");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST actions_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"actions",1,912);
				action();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop954:
				do {
					if ((LA(1)==KW_AND)) {
						it.polimi.recovery.nodes.AndNode tmp53_AST = null;
						tmp53_AST = (it.polimi.recovery.nodes.AndNode)astFactory.create(LT(1),"it.polimi.recovery.nodes.AndNode");
						astFactory.makeASTRoot(currentAST, tmp53_AST);
						bShouldFire=aboutToEnter(bShouldFire,"actions",2,922);
						match(KW_AND);
						bShouldFire=aboutToEnter(bShouldFire,"actions",3,924);
						action();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop954;
					}
					
				} while (true);
				}
				actions_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_6);
				} else {
				  throw ex;
				}
			}
			returnAST = actions_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void action() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("action");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST action_AST = null;
			Token  m = null;
			it.polimi.recovery.nodes.SimpleAST m_AST = null;
			AST l_AST = null;
			
			try {      // for error handling
				m = LT(1);
				m_AST = (it.polimi.recovery.nodes.SimpleAST)astFactory.create(m,"it.polimi.recovery.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"action",1,968);
				match(IDENTIFIER);
				AST tmp54_AST = null;
				tmp54_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"action",2,972);
				match(LEFT_PAREN);
				{
				switch ( LA(1)) {
				case KW_TRUE:
				case KW_FALSE:
				case KW_LET:
				case KW_STORE:
				case KW_RETRIEVE:
				case KW_RESP_TIME:
				case KW_RETURN_NUMBER:
				case KW_RETURN_BOOL:
				case KW_RETURN_STRING:
				case LITERAL:
				case NUMBER:
				case IDENTIFIER:
				case LEFT_PAREN:
				case DOLLAR_SIGN:
				{
					bShouldFire=aboutToEnter(bShouldFire,"action",3,991);
					list();
					l_AST = (AST)returnAST;
					break;
				}
				case RIGHT_PAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				AST tmp55_AST = null;
				tmp55_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"action",4,1008);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					action_AST = (AST)currentAST.root;
					
							action_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(ACTION,"Action","it.polimi.recovery.nodes.ActionNode")).add(m_AST).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(PARAM_LIST,"Param_List","it.polimi.monitor.nodes.PARAM_LISTNode")).add(l_AST)))); 
						
					currentAST.root = action_AST;
					currentAST.child = action_AST!=null &&action_AST.getFirstChild()!=null ?
						action_AST.getFirstChild() : action_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_7);
				} else {
				  throw ex;
				}
			}
			returnAST = action_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void list() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("list");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST list_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"list",1,1048);
				sub_rule();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop1009:
				do {
					if ((LA(1)==COMMA)) {
						bShouldFire=aboutToEnter(bShouldFire,"list",2,1055);
						match(COMMA);
						bShouldFire=aboutToEnter(bShouldFire,"list",3,1057);
						sub_rule();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop1009;
					}
					
				} while (true);
				}
				list_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_8);
				} else {
				  throw ex;
				}
			}
			returnAST = list_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void rule() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("rule");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST rule_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"rule",1,1096);
				sub_rule();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop963:
				do {
					if (((LA(1) >= KW_LR_IMPLIES && LA(1) <= KW_2WIMPLIES))) {
						{
						switch ( LA(1)) {
						case KW_LR_IMPLIES:
						{
							it.polimi.monitor.nodes.binary.LeftImpliesNode tmp57_AST = null;
							tmp57_AST = (it.polimi.monitor.nodes.binary.LeftImpliesNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.LeftImpliesNode");
							astFactory.makeASTRoot(currentAST, tmp57_AST);
							bShouldFire=aboutToEnter(bShouldFire,"rule",2,1110);
							match(KW_LR_IMPLIES);
							break;
						}
						case KW_RL_IMPLIES:
						{
							it.polimi.monitor.nodes.binary.RightImpliesNode tmp58_AST = null;
							tmp58_AST = (it.polimi.monitor.nodes.binary.RightImpliesNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.RightImpliesNode");
							astFactory.makeASTRoot(currentAST, tmp58_AST);
							bShouldFire=aboutToEnter(bShouldFire,"rule",3,1119);
							match(KW_RL_IMPLIES);
							break;
						}
						case KW_2WIMPLIES:
						{
							it.polimi.monitor.nodes.binary.DoubleImpliesNode tmp59_AST = null;
							tmp59_AST = (it.polimi.monitor.nodes.binary.DoubleImpliesNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.DoubleImpliesNode");
							astFactory.makeASTRoot(currentAST, tmp59_AST);
							bShouldFire=aboutToEnter(bShouldFire,"rule",4,1128);
							match(KW_2WIMPLIES);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						bShouldFire=aboutToEnter(bShouldFire,"rule",5,1138);
						sub_rule();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop963;
					}
					
				} while (true);
				}
				bShouldFire=aboutToEnter(bShouldFire,"rule",6,1148);
				match(SEMI);
				rule_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_9);
				} else {
				  throw ex;
				}
			}
			returnAST = rule_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void sub_rule() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("sub_rule");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST sub_rule_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"sub_rule",1,1179);
				and_expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop966:
				do {
					if ((LA(1)==OR) && (_tokenSet_1.member(LA(2))) && (_tokenSet_10.member(LA(3))) && (_tokenSet_11.member(LA(4)))) {
						it.polimi.monitor.nodes.binary.LogicalOperatorNode tmp61_AST = null;
						tmp61_AST = (it.polimi.monitor.nodes.binary.LogicalOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.LogicalOperatorNode");
						astFactory.makeASTRoot(currentAST, tmp61_AST);
						bShouldFire=aboutToEnter(bShouldFire,"sub_rule",2,1189);
						match(OR);
						bShouldFire=aboutToEnter(bShouldFire,"sub_rule",3,1191);
						and_expression();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop966;
					}
					
				} while (true);
				}
				sub_rule_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = sub_rule_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void and_expression() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("and_expression");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST and_expression_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"and_expression",1,1230);
				equals_expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop969:
				do {
					if ((LA(1)==AND) && (_tokenSet_1.member(LA(2))) && (_tokenSet_10.member(LA(3))) && (_tokenSet_11.member(LA(4)))) {
						it.polimi.monitor.nodes.binary.LogicalOperatorNode tmp62_AST = null;
						tmp62_AST = (it.polimi.monitor.nodes.binary.LogicalOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.LogicalOperatorNode");
						astFactory.makeASTRoot(currentAST, tmp62_AST);
						bShouldFire=aboutToEnter(bShouldFire,"and_expression",2,1240);
						match(AND);
						bShouldFire=aboutToEnter(bShouldFire,"and_expression",3,1242);
						equals_expression();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop969;
					}
					
				} while (true);
				}
				and_expression_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = and_expression_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void equals_expression() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("equals_expression");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST equals_expression_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"equals_expression",1,1281);
				relational_expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				if ((LA(1)==DOUBLE_EQUALS||LA(1)==NOT_EQUALS) && (_tokenSet_1.member(LA(2))) && (_tokenSet_10.member(LA(3))) && (_tokenSet_11.member(LA(4)))) {
					{
					switch ( LA(1)) {
					case DOUBLE_EQUALS:
					{
						it.polimi.monitor.nodes.binary.OperatorNode tmp63_AST = null;
						tmp63_AST = (it.polimi.monitor.nodes.binary.OperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.OperatorNode");
						astFactory.makeASTRoot(currentAST, tmp63_AST);
						bShouldFire=aboutToEnter(bShouldFire,"equals_expression",2,1293);
						match(DOUBLE_EQUALS);
						break;
					}
					case NOT_EQUALS:
					{
						it.polimi.monitor.nodes.binary.OperatorNode tmp64_AST = null;
						tmp64_AST = (it.polimi.monitor.nodes.binary.OperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.OperatorNode");
						astFactory.makeASTRoot(currentAST, tmp64_AST);
						bShouldFire=aboutToEnter(bShouldFire,"equals_expression",3,1302);
						match(NOT_EQUALS);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					bShouldFire=aboutToEnter(bShouldFire,"equals_expression",4,1312);
					relational_expression();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else if ((_tokenSet_12.member(LA(1))) && (_tokenSet_13.member(LA(2))) && (_tokenSet_14.member(LA(3))) && (_tokenSet_15.member(LA(4)))) {
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				equals_expression_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = equals_expression_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void relational_expression() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("relational_expression");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST relational_expression_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"relational_expression",1,1352);
				operator_expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				if (((LA(1) >= LT && LA(1) <= GTE)) && (_tokenSet_1.member(LA(2))) && (_tokenSet_10.member(LA(3))) && (_tokenSet_11.member(LA(4)))) {
					{
					switch ( LA(1)) {
					case GT:
					{
						it.polimi.monitor.nodes.binary.GLOperatorNode tmp65_AST = null;
						tmp65_AST = (it.polimi.monitor.nodes.binary.GLOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.GLOperatorNode");
						astFactory.makeASTRoot(currentAST, tmp65_AST);
						bShouldFire=aboutToEnter(bShouldFire,"relational_expression",2,1364);
						match(GT);
						break;
					}
					case GTE:
					{
						it.polimi.monitor.nodes.binary.GLOperatorNode tmp66_AST = null;
						tmp66_AST = (it.polimi.monitor.nodes.binary.GLOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.GLOperatorNode");
						astFactory.makeASTRoot(currentAST, tmp66_AST);
						bShouldFire=aboutToEnter(bShouldFire,"relational_expression",3,1373);
						match(GTE);
						break;
					}
					case LT:
					{
						it.polimi.monitor.nodes.binary.GLOperatorNode tmp67_AST = null;
						tmp67_AST = (it.polimi.monitor.nodes.binary.GLOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.GLOperatorNode");
						astFactory.makeASTRoot(currentAST, tmp67_AST);
						bShouldFire=aboutToEnter(bShouldFire,"relational_expression",4,1382);
						match(LT);
						break;
					}
					case LTE:
					{
						it.polimi.monitor.nodes.binary.GLOperatorNode tmp68_AST = null;
						tmp68_AST = (it.polimi.monitor.nodes.binary.GLOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.GLOperatorNode");
						astFactory.makeASTRoot(currentAST, tmp68_AST);
						bShouldFire=aboutToEnter(bShouldFire,"relational_expression",5,1391);
						match(LTE);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					bShouldFire=aboutToEnter(bShouldFire,"relational_expression",6,1401);
					operator_expression();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else if ((_tokenSet_12.member(LA(1))) && (_tokenSet_13.member(LA(2))) && (_tokenSet_14.member(LA(3))) && (_tokenSet_15.member(LA(4)))) {
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				relational_expression_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = relational_expression_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void operator_expression() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("operator_expression");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST operator_expression_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"operator_expression",1,1441);
				basic_expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop979:
				do {
					if ((_tokenSet_16.member(LA(1))) && (_tokenSet_1.member(LA(2))) && (_tokenSet_10.member(LA(3))) && (_tokenSet_11.member(LA(4)))) {
						{
						switch ( LA(1)) {
						case PLUS:
						{
							it.polimi.monitor.nodes.binary.NumberOperatorNode tmp69_AST = null;
							tmp69_AST = (it.polimi.monitor.nodes.binary.NumberOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.NumberOperatorNode");
							astFactory.makeASTRoot(currentAST, tmp69_AST);
							bShouldFire=aboutToEnter(bShouldFire,"operator_expression",2,1455);
							match(PLUS);
							break;
						}
						case MINUS:
						{
							it.polimi.monitor.nodes.binary.NumberOperatorNode tmp70_AST = null;
							tmp70_AST = (it.polimi.monitor.nodes.binary.NumberOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.NumberOperatorNode");
							astFactory.makeASTRoot(currentAST, tmp70_AST);
							bShouldFire=aboutToEnter(bShouldFire,"operator_expression",3,1464);
							match(MINUS);
							break;
						}
						case STAR:
						{
							it.polimi.monitor.nodes.binary.NumberOperatorNode tmp71_AST = null;
							tmp71_AST = (it.polimi.monitor.nodes.binary.NumberOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.NumberOperatorNode");
							astFactory.makeASTRoot(currentAST, tmp71_AST);
							bShouldFire=aboutToEnter(bShouldFire,"operator_expression",4,1473);
							match(STAR);
							break;
						}
						case SLASH:
						{
							it.polimi.monitor.nodes.binary.NumberOperatorNode tmp72_AST = null;
							tmp72_AST = (it.polimi.monitor.nodes.binary.NumberOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.NumberOperatorNode");
							astFactory.makeASTRoot(currentAST, tmp72_AST);
							bShouldFire=aboutToEnter(bShouldFire,"operator_expression",5,1482);
							match(SLASH);
							break;
						}
						case PERCENTAGE:
						{
							it.polimi.monitor.nodes.binary.NumberOperatorNode tmp73_AST = null;
							tmp73_AST = (it.polimi.monitor.nodes.binary.NumberOperatorNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.NumberOperatorNode");
							astFactory.makeASTRoot(currentAST, tmp73_AST);
							bShouldFire=aboutToEnter(bShouldFire,"operator_expression",6,1491);
							match(PERCENTAGE);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						bShouldFire=aboutToEnter(bShouldFire,"operator_expression",7,1501);
						basic_expression();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop979;
					}
					
				} while (true);
				}
				operator_expression_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = operator_expression_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void basic_expression() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("basic_expression");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST basic_expression_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case KW_LET:
				{
					bShouldFire=aboutToEnter(bShouldFire,"basic_expression",1,1543);
					let();
					astFactory.addASTChild(currentAST, returnAST);
					basic_expression_AST = (AST)currentAST.root;
					break;
				}
				case KW_STORE:
				{
					bShouldFire=aboutToEnter(bShouldFire,"basic_expression",2,1551);
					store();
					astFactory.addASTChild(currentAST, returnAST);
					basic_expression_AST = (AST)currentAST.root;
					break;
				}
				case KW_RESP_TIME:
				{
					bShouldFire=aboutToEnter(bShouldFire,"basic_expression",3,1559);
					resp_time();
					astFactory.addASTChild(currentAST, returnAST);
					basic_expression_AST = (AST)currentAST.root;
					break;
				}
				case KW_TRUE:
				{
					it.polimi.monitor.nodes.SimpleAST tmp74_AST = null;
					tmp74_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(LT(1),"it.polimi.monitor.nodes.SimpleAST");
					astFactory.addASTChild(currentAST, tmp74_AST);
					bShouldFire=aboutToEnter(bShouldFire,"basic_expression",4,1570);
					match(KW_TRUE);
					basic_expression_AST = (AST)currentAST.root;
					break;
				}
				case KW_FALSE:
				{
					it.polimi.monitor.nodes.SimpleAST tmp75_AST = null;
					tmp75_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(LT(1),"it.polimi.monitor.nodes.SimpleAST");
					astFactory.addASTChild(currentAST, tmp75_AST);
					bShouldFire=aboutToEnter(bShouldFire,"basic_expression",5,1580);
					match(KW_FALSE);
					basic_expression_AST = (AST)currentAST.root;
					break;
				}
				case NUMBER:
				{
					it.polimi.monitor.nodes.SimpleAST tmp76_AST = null;
					tmp76_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(LT(1),"it.polimi.monitor.nodes.SimpleAST");
					astFactory.addASTChild(currentAST, tmp76_AST);
					bShouldFire=aboutToEnter(bShouldFire,"basic_expression",6,1590);
					match(NUMBER);
					basic_expression_AST = (AST)currentAST.root;
					break;
				}
				default:
					boolean synPredMatched982 = false;
					if (((_tokenSet_17.member(LA(1))) && (_tokenSet_18.member(LA(2))) && (_tokenSet_19.member(LA(3))) && (_tokenSet_20.member(LA(4))))) {
						int _m982 = mark();
						synPredMatched982 = true;
						inputState.guessing++;
						try {
							{
							bShouldFire=aboutToEnter(bShouldFire,"basic_expression",7,1603);
							variable();
							bShouldFire=aboutToEnter(bShouldFire,"basic_expression",8,1605);
							match(DOT);
							}
						}
						catch (RecognitionException pe) {
							synPredMatched982 = false;
						}
						rewind(_m982);
inputState.guessing--;
					}
					if ( synPredMatched982 ) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",9,1616);
						dot_expression();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((_tokenSet_17.member(LA(1))) && (_tokenSet_18.member(LA(2))) && (_tokenSet_21.member(LA(3))) && (_tokenSet_22.member(LA(4)))) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",10,1622);
						variable();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((LA(1)==LEFT_PAREN) && (LA(2)==KW_EXISTS)) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",11,1628);
						exists();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((LA(1)==LEFT_PAREN) && (LA(2)==KW_FORALL)) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",12,1634);
						forall();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((LA(1)==LEFT_PAREN) && (LA(2)==KW_AVG)) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",13,1640);
						avg();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((LA(1)==LEFT_PAREN) && (LA(2)==KW_MIN)) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",14,1646);
						min();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((LA(1)==LEFT_PAREN) && (LA(2)==KW_MAX)) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",15,1652);
						max();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((LA(1)==LEFT_PAREN) && (LA(2)==KW_SUM)) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",16,1658);
						sum();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((LA(1)==LEFT_PAREN) && (LA(2)==KW_PRODUCT)) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",17,1664);
						product();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
					else if ((_tokenSet_23.member(LA(1))) && (_tokenSet_24.member(LA(2))) && (_tokenSet_11.member(LA(3))) && (_tokenSet_25.member(LA(4)))) {
						bShouldFire=aboutToEnter(bShouldFire,"basic_expression",18,1670);
						string_value();
						astFactory.addASTChild(currentAST, returnAST);
						basic_expression_AST = (AST)currentAST.root;
					}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = basic_expression_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void variable() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("variable");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST variable_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case LEFT_PAREN:
				{
					bShouldFire=aboutToEnter(bShouldFire,"variable",1,1710);
					match(LEFT_PAREN);
					{
					switch ( LA(1)) {
					case DOLLAR_SIGN:
					{
						bShouldFire=aboutToEnter(bShouldFire,"variable",2,1716);
						ivar();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					case KW_RETURN_NUMBER:
					case KW_RETURN_BOOL:
					case KW_RETURN_STRING:
					{
						bShouldFire=aboutToEnter(bShouldFire,"variable",3,1725);
						evar();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					case KW_RETRIEVE:
					{
						bShouldFire=aboutToEnter(bShouldFire,"variable",4,1732);
						hvar();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					bShouldFire=aboutToEnter(bShouldFire,"variable",5,1743);
					match(RIGHT_PAREN);
					variable_AST = (AST)currentAST.root;
					break;
				}
				case KW_RETRIEVE:
				case KW_RETURN_NUMBER:
				case KW_RETURN_BOOL:
				case KW_RETURN_STRING:
				case DOLLAR_SIGN:
				{
					{
					switch ( LA(1)) {
					case DOLLAR_SIGN:
					{
						bShouldFire=aboutToEnter(bShouldFire,"variable",6,1758);
						ivar();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					case KW_RETURN_NUMBER:
					case KW_RETURN_BOOL:
					case KW_RETURN_STRING:
					{
						bShouldFire=aboutToEnter(bShouldFire,"variable",7,1767);
						evar();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					case KW_RETRIEVE:
					{
						bShouldFire=aboutToEnter(bShouldFire,"variable",8,1774);
						hvar();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					variable_AST = (AST)currentAST.root;
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_26);
				} else {
				  throw ex;
				}
			}
			returnAST = variable_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void dot_expression() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("dot_expression");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST dot_expression_AST = null;
			AST v_AST = null;
			Token  m = null;
			it.polimi.monitor.nodes.SimpleAST m_AST = null;
			AST l_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"dot_expression",1,1825);
				variable();
				v_AST = (AST)returnAST;
				AST tmp79_AST = null;
				tmp79_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"dot_expression",2,1830);
				match(DOT);
				m = LT(1);
				m_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(m,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"dot_expression",3,1834);
				match(IDENTIFIER);
				AST tmp80_AST = null;
				tmp80_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"dot_expression",4,1838);
				match(LEFT_PAREN);
				{
				switch ( LA(1)) {
				case KW_TRUE:
				case KW_FALSE:
				case KW_LET:
				case KW_STORE:
				case KW_RETRIEVE:
				case KW_RESP_TIME:
				case KW_RETURN_NUMBER:
				case KW_RETURN_BOOL:
				case KW_RETURN_STRING:
				case LITERAL:
				case NUMBER:
				case IDENTIFIER:
				case LEFT_PAREN:
				case DOLLAR_SIGN:
				{
					bShouldFire=aboutToEnter(bShouldFire,"dot_expression",5,1857);
					list();
					l_AST = (AST)returnAST;
					break;
				}
				case RIGHT_PAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				AST tmp81_AST = null;
				tmp81_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"dot_expression",6,1874);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					dot_expression_AST = (AST)currentAST.root;
					
							dot_expression_AST = (AST)astFactory.make( (new ASTArray(4)).add((AST)astFactory.create(METHOD,"Method","it.polimi.monitor.nodes.METHODNode")).add(v_AST).add(m_AST).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(PARAM_LIST,"Param_List","it.polimi.monitor.nodes.PARAM_LISTNode")).add(l_AST)))); 
						//	#dot_expression = #([METHOD, "Method"], #(#m, #v, #([PARAM_LIST, "Param_List"], #l)));
						
					currentAST.root = dot_expression_AST;
					currentAST.child = dot_expression_AST!=null &&dot_expression_AST.getFirstChild()!=null ?
						dot_expression_AST.getFirstChild() : dot_expression_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = dot_expression_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void exists() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("exists");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST exists_AST = null;
			Token  v = null;
			it.polimi.monitor.nodes.SimpleAST v_AST = null;
			AST s_AST = null;
			AST r_AST = null;
			
			try {      // for error handling
				AST tmp82_AST = null;
				tmp82_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"exists",1,1921);
				match(LEFT_PAREN);
				AST tmp83_AST = null;
				tmp83_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"exists",2,1925);
				match(KW_EXISTS);
				AST tmp84_AST = null;
				tmp84_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"exists",3,1929);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(v,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"exists",4,1933);
				match(IDENTIFIER);
				AST tmp85_AST = null;
				tmp85_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"exists",5,1937);
				match(KW_IN);
				bShouldFire=aboutToEnter(bShouldFire,"exists",6,1939);
				variable();
				s_AST = (AST)returnAST;
				AST tmp86_AST = null;
				tmp86_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"exists",7,1944);
				match(SEMI);
				bShouldFire=aboutToEnter(bShouldFire,"exists",8,1946);
				sub_rule();
				r_AST = (AST)returnAST;
				AST tmp87_AST = null;
				tmp87_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"exists",9,1951);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					exists_AST = (AST)currentAST.root;
					if (symbols.get(v.getText())==null ) 
								symbols.put(v.getText(), new Symbol(v.getText()));
							else {
								inputState.guessing++;
								throw new it.polimi.exception.DuplicateIdentifierException();
							}
							exists_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(EXISTS,"Existsl","it.polimi.monitor.nodes.complex.EXISTSNode")).add((AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(VAR,"Variable","it.polimi.monitor.nodes.AliasNode")).add(v_AST).add(s_AST))).add(r_AST));
							{
								symbols.remove(v.getText());
							}
							
						
					currentAST.root = exists_AST;
					currentAST.child = exists_AST!=null &&exists_AST.getFirstChild()!=null ?
						exists_AST.getFirstChild() : exists_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = exists_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void forall() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("forall");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST forall_AST = null;
			Token  v = null;
			it.polimi.monitor.nodes.SimpleAST v_AST = null;
			AST s_AST = null;
			AST r_AST = null;
			
			try {      // for error handling
				AST tmp88_AST = null;
				tmp88_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"forall",1,2006);
				match(LEFT_PAREN);
				AST tmp89_AST = null;
				tmp89_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"forall",2,2010);
				match(KW_FORALL);
				AST tmp90_AST = null;
				tmp90_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"forall",3,2014);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(v,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"forall",4,2018);
				match(IDENTIFIER);
				AST tmp91_AST = null;
				tmp91_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"forall",5,2022);
				match(KW_IN);
				bShouldFire=aboutToEnter(bShouldFire,"forall",6,2024);
				variable();
				s_AST = (AST)returnAST;
				AST tmp92_AST = null;
				tmp92_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"forall",7,2029);
				match(SEMI);
				bShouldFire=aboutToEnter(bShouldFire,"forall",8,2031);
				sub_rule();
				r_AST = (AST)returnAST;
				AST tmp93_AST = null;
				tmp93_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"forall",9,2036);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					forall_AST = (AST)currentAST.root;
						
							 if (symbols.get(v.getText())==null ) 
								symbols.put(v.getText(), new Symbol(v.getText()));
							else {
								inputState.guessing++;
								throw new it.polimi.exception.DuplicateIdentifierException();
							}
							forall_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(FORALL,"Forall","it.polimi.monitor.nodes.complex.FORALLNode")).add((AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(VAR,"Variable","it.polimi.monitor.nodes.AliasNode")).add(v_AST).add(s_AST))).add(r_AST));
							{
								symbols.remove(v.getText());
							}
						
					currentAST.root = forall_AST;
					currentAST.child = forall_AST!=null &&forall_AST.getFirstChild()!=null ?
						forall_AST.getFirstChild() : forall_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = forall_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void let() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("let");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST let_AST = null;
			Token  i = null;
			it.polimi.monitor.nodes.SimpleAST i_AST = null;
			AST s_AST = null;
			
			try {      // for error handling
				AST tmp94_AST = null;
				tmp94_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"let",1,2090);
				match(KW_LET);
				AST tmp95_AST = null;
				tmp95_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"let",2,2094);
				match(DOLLAR_SIGN);
				i = LT(1);
				i_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(i,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"let",3,2098);
				match(IDENTIFIER);
				AST tmp96_AST = null;
				tmp96_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"let",4,2102);
				match(EQUALS);
				bShouldFire=aboutToEnter(bShouldFire,"let",5,2104);
				sub_rule();
				s_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					let_AST = (AST)currentAST.root;
					if (symbols.get(i.getText())==null ) 
								symbols.put(i.getText(), new Symbol(i.getText()));
							else {
								inputState.guessing++;
								throw new it.polimi.exception.DuplicateIdentifierException();
							}
							let_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(LET,"Letsl","it.polimi.monitor.nodes.LetNode")).add(i_AST).add(s_AST)); 
						
					currentAST.root = let_AST;
					currentAST.child = let_AST!=null &&let_AST.getFirstChild()!=null ?
						let_AST.getFirstChild() : let_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = let_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void store() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("store");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST store_AST = null;
			Token  i = null;
			it.polimi.monitor.nodes.SimpleAST i_AST = null;
			AST x_AST = null;
			
			try {      // for error handling
				AST tmp97_AST = null;
				tmp97_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"store",1,2155);
				match(KW_STORE);
				AST tmp98_AST = null;
				tmp98_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"store",2,2159);
				match(DOLLAR_SIGN);
				i = LT(1);
				i_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(i,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"store",3,2163);
				match(IDENTIFIER);
				AST tmp99_AST = null;
				tmp99_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"store",4,2167);
				match(EQUALS);
				bShouldFire=aboutToEnter(bShouldFire,"store",5,2169);
				sub_rule();
				x_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					store_AST = (AST)currentAST.root;
					if (symbols.get(i.getText())==null ) 
								symbols.put(i.getText(), new Symbol(i.getText()));
							else {
								inputState.guessing++;
								throw new it.polimi.exception.DuplicateIdentifierException();
							}
							store_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(STORE,"Storesl","it.polimi.monitor.nodes.StoreNode")).add(i_AST).add(x_AST));
						
					currentAST.root = store_AST;
					currentAST.child = store_AST!=null &&store_AST.getFirstChild()!=null ?
						store_AST.getFirstChild() : store_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = store_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void resp_time() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("resp_time");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST resp_time_AST = null;
			
			try {      // for error handling
				AST tmp100_AST = null;
				tmp100_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp100_AST);
				bShouldFire=aboutToEnter(bShouldFire,"resp_time",1,2218);
				match(KW_RESP_TIME);
				resp_time_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = resp_time_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void avg() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("avg");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST avg_AST = null;
			Token  v = null;
			it.polimi.monitor.nodes.SimpleAST v_AST = null;
			AST s_AST = null;
			AST r_AST = null;
			
			try {      // for error handling
				AST tmp101_AST = null;
				tmp101_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"avg",1,2255);
				match(LEFT_PAREN);
				AST tmp102_AST = null;
				tmp102_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"avg",2,2259);
				match(KW_AVG);
				AST tmp103_AST = null;
				tmp103_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"avg",3,2263);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(v,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"avg",4,2267);
				match(IDENTIFIER);
				AST tmp104_AST = null;
				tmp104_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"avg",5,2271);
				match(KW_IN);
				bShouldFire=aboutToEnter(bShouldFire,"avg",6,2273);
				variable();
				s_AST = (AST)returnAST;
				AST tmp105_AST = null;
				tmp105_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"avg",7,2278);
				match(SEMI);
				bShouldFire=aboutToEnter(bShouldFire,"avg",8,2280);
				sub_rule();
				r_AST = (AST)returnAST;
				AST tmp106_AST = null;
				tmp106_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"avg",9,2285);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					avg_AST = (AST)currentAST.root;
					
								 if (symbols.get(v.getText())==null ) 
									symbols.put(v.getText(), new Symbol(v.getText()));
								else {
									inputState.guessing++;
									throw new it.polimi.exception.DuplicateIdentifierException();
								}
							avg_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(AVG,"Avg","it.polimi.monitor.nodes.complex.AvgNode")).add((AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(VAR,"Variable","it.polimi.monitor.nodes.AliasNode")).add(v_AST).add(s_AST))).add(r_AST));
							{
								symbols.remove(v.getText());
							}
						
					currentAST.root = avg_AST;
					currentAST.child = avg_AST!=null &&avg_AST.getFirstChild()!=null ?
						avg_AST.getFirstChild() : avg_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = avg_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void min() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("min");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST min_AST = null;
			Token  v = null;
			it.polimi.monitor.nodes.SimpleAST v_AST = null;
			AST s_AST = null;
			AST r_AST = null;
			
			try {      // for error handling
				AST tmp107_AST = null;
				tmp107_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"min",1,2340);
				match(LEFT_PAREN);
				AST tmp108_AST = null;
				tmp108_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"min",2,2344);
				match(KW_MIN);
				AST tmp109_AST = null;
				tmp109_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"min",3,2348);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(v,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"min",4,2352);
				match(IDENTIFIER);
				AST tmp110_AST = null;
				tmp110_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"min",5,2356);
				match(KW_IN);
				bShouldFire=aboutToEnter(bShouldFire,"min",6,2358);
				variable();
				s_AST = (AST)returnAST;
				AST tmp111_AST = null;
				tmp111_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"min",7,2363);
				match(SEMI);
				bShouldFire=aboutToEnter(bShouldFire,"min",8,2365);
				sub_rule();
				r_AST = (AST)returnAST;
				AST tmp112_AST = null;
				tmp112_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"min",9,2370);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					min_AST = (AST)currentAST.root;
					if (symbols.get(v.getText())==null ) 
								symbols.put(v.getText(), new Symbol(v.getText()));
							else {
								inputState.guessing++;
								throw new it.polimi.exception.DuplicateIdentifierException();
							}
							min_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(MIN,"Min","it.polimi.monitor.nodes.complex.MinNode")).add((AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(VAR,"Variable","it.polimi.monitor.nodes.AliasNode")).add(v_AST).add(s_AST))).add(r_AST));
							{
								symbols.remove(v.getText());
							}
						
					currentAST.root = min_AST;
					currentAST.child = min_AST!=null &&min_AST.getFirstChild()!=null ?
						min_AST.getFirstChild() : min_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = min_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void max() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("max");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST max_AST = null;
			Token  v = null;
			it.polimi.monitor.nodes.SimpleAST v_AST = null;
			AST s_AST = null;
			AST r_AST = null;
			
			try {      // for error handling
				AST tmp113_AST = null;
				tmp113_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"max",1,2424);
				match(LEFT_PAREN);
				AST tmp114_AST = null;
				tmp114_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"max",2,2428);
				match(KW_MAX);
				AST tmp115_AST = null;
				tmp115_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"max",3,2432);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(v,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"max",4,2436);
				match(IDENTIFIER);
				AST tmp116_AST = null;
				tmp116_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"max",5,2440);
				match(KW_IN);
				bShouldFire=aboutToEnter(bShouldFire,"max",6,2442);
				variable();
				s_AST = (AST)returnAST;
				AST tmp117_AST = null;
				tmp117_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"max",7,2447);
				match(SEMI);
				bShouldFire=aboutToEnter(bShouldFire,"max",8,2449);
				sub_rule();
				r_AST = (AST)returnAST;
				AST tmp118_AST = null;
				tmp118_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"max",9,2454);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					max_AST = (AST)currentAST.root;
					if (symbols.get(v.getText())==null ) 
								symbols.put(v.getText(), new Symbol(v.getText()));
							else {
								inputState.guessing++;
								throw new it.polimi.exception.DuplicateIdentifierException();
							}
							max_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(MAX,"Max","it.polimi.monitor.nodes.complex.MaxNode")).add((AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(VAR,"Variable","it.polimi.monitor.nodes.AliasNode")).add(v_AST).add(s_AST))).add(r_AST));
							{
								symbols.remove(v.getText());
							}
						
					currentAST.root = max_AST;
					currentAST.child = max_AST!=null &&max_AST.getFirstChild()!=null ?
						max_AST.getFirstChild() : max_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = max_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void sum() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("sum");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST sum_AST = null;
			Token  v = null;
			it.polimi.monitor.nodes.SimpleAST v_AST = null;
			AST s_AST = null;
			AST r_AST = null;
			
			try {      // for error handling
				AST tmp119_AST = null;
				tmp119_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"sum",1,2508);
				match(LEFT_PAREN);
				AST tmp120_AST = null;
				tmp120_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"sum",2,2512);
				match(KW_SUM);
				AST tmp121_AST = null;
				tmp121_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"sum",3,2516);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(v,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"sum",4,2520);
				match(IDENTIFIER);
				AST tmp122_AST = null;
				tmp122_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"sum",5,2524);
				match(KW_IN);
				bShouldFire=aboutToEnter(bShouldFire,"sum",6,2526);
				variable();
				s_AST = (AST)returnAST;
				AST tmp123_AST = null;
				tmp123_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"sum",7,2531);
				match(SEMI);
				bShouldFire=aboutToEnter(bShouldFire,"sum",8,2533);
				sub_rule();
				r_AST = (AST)returnAST;
				AST tmp124_AST = null;
				tmp124_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"sum",9,2538);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					sum_AST = (AST)currentAST.root;
					if (symbols.get(v.getText())==null ) 
									symbols.put(v.getText(), new Symbol(v.getText()));
								else {
									inputState.guessing++;
									throw new it.polimi.exception.DuplicateIdentifierException();
								}
							sum_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(SUM,"Sum","it.polimi.monitor.nodes.complex.SumNode")).add((AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(VAR,"Variable","it.polimi.monitor.nodes.AliasNode")).add(v_AST).add(s_AST))).add(r_AST));
							{
								symbols.remove(v.getText());
							}
						
					currentAST.root = sum_AST;
					currentAST.child = sum_AST!=null &&sum_AST.getFirstChild()!=null ?
						sum_AST.getFirstChild() : sum_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = sum_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void product() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("product");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST product_AST = null;
			Token  v = null;
			it.polimi.monitor.nodes.SimpleAST v_AST = null;
			AST s_AST = null;
			AST r_AST = null;
			
			try {      // for error handling
				AST tmp125_AST = null;
				tmp125_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"product",1,2592);
				match(LEFT_PAREN);
				AST tmp126_AST = null;
				tmp126_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"product",2,2596);
				match(KW_PRODUCT);
				AST tmp127_AST = null;
				tmp127_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"product",3,2600);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(v,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"product",4,2604);
				match(IDENTIFIER);
				AST tmp128_AST = null;
				tmp128_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"product",5,2608);
				match(KW_IN);
				bShouldFire=aboutToEnter(bShouldFire,"product",6,2610);
				variable();
				s_AST = (AST)returnAST;
				AST tmp129_AST = null;
				tmp129_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"product",7,2615);
				match(SEMI);
				bShouldFire=aboutToEnter(bShouldFire,"product",8,2617);
				sub_rule();
				r_AST = (AST)returnAST;
				AST tmp130_AST = null;
				tmp130_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"product",9,2622);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					product_AST = (AST)currentAST.root;
					if (symbols.get(v.getText())==null ) 
								symbols.put(v.getText(), new Symbol(v.getText()));
							else {
								inputState.guessing++;
								throw new it.polimi.exception.DuplicateIdentifierException();
							}
							product_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(PRODUCT,"Product","it.polimi.monitor.nodes.complex.ProductNode")).add((AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(VAR,"Variable","it.polimi.monitor.nodes.AliasNode")).add(v_AST).add(s_AST))).add(r_AST));
							{
								symbols.remove(v.getText());
							}
						
					currentAST.root = product_AST;
					currentAST.child = product_AST!=null &&product_AST.getFirstChild()!=null ?
						product_AST.getFirstChild() : product_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_12);
				} else {
				  throw ex;
				}
			}
			returnAST = product_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void string_value() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("string_value");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST string_value_AST = null;
			AST s1_AST = null;
			AST s2_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"string_value",1,2672);
				sub_string_value();
				s1_AST = (AST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop1012:
				do {
					if ((LA(1)==PLUS) && (_tokenSet_23.member(LA(2))) && (_tokenSet_27.member(LA(3))) && (_tokenSet_28.member(LA(4)))) {
						it.polimi.monitor.nodes.binary.PLUSNode tmp131_AST = null;
						tmp131_AST = (it.polimi.monitor.nodes.binary.PLUSNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.binary.PLUSNode");
						astFactory.makeASTRoot(currentAST, tmp131_AST);
						bShouldFire=aboutToEnter(bShouldFire,"string_value",2,2683);
						match(PLUS);
						bShouldFire=aboutToEnter(bShouldFire,"string_value",3,2685);
						sub_string_value();
						s2_AST = (AST)returnAST;
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop1012;
					}
					
				} while (true);
				}
				string_value_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_29);
				} else {
				  throw ex;
				}
			}
			returnAST = string_value_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void ivar() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("ivar");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST ivar_AST = null;
			Token  v = null;
			it.polimi.monitor.nodes.SimpleAST v_AST = null;
			AST x_AST = null;
			
			try {      // for error handling
				AST tmp132_AST = null;
				tmp132_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"ivar",1,2730);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(v,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"ivar",2,2734);
				match(IDENTIFIER);
				{
				if ((_tokenSet_30.member(LA(1))) && (_tokenSet_31.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
					bShouldFire=aboutToEnter(bShouldFire,"ivar",3,2738);
					xpath_expression();
					x_AST = (AST)returnAST;
				}
				else if ((_tokenSet_26.member(LA(1))) && (_tokenSet_28.member(LA(2))) && (_tokenSet_25.member(LA(3))) && (_tokenSet_34.member(LA(4)))) {
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				if ( inputState.guessing==0 ) {
					ivar_AST = (AST)currentAST.root;
					
							ivar_AST = (AST)astFactory.make( (new ASTArray(3)).add((AST)astFactory.create(INTERNAL_VARIABLE,"BPEL_VAR","it.polimi.monitor.nodes.InternalVarNode")).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(VAR,"Variable","it.polimi.monitor.nodes.VariableNode")).add(v_AST))).add(x_AST)); 
						
					currentAST.root = ivar_AST;
					currentAST.child = ivar_AST!=null &&ivar_AST.getFirstChild()!=null ?
						ivar_AST.getFirstChild() : ivar_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_26);
				} else {
				  throw ex;
				}
			}
			returnAST = ivar_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void evar() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("evar");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST evar_AST = null;
			AST r_AST = null;
			AST wsdl_AST = null;
			AST wm_AST = null;
			AST ins_AST = null;
			AST outs_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"evar",1,2792);
				returnType();
				r_AST = (AST)returnAST;
				AST tmp133_AST = null;
				tmp133_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"evar",2,2797);
				match(LEFT_PAREN);
				bShouldFire=aboutToEnter(bShouldFire,"evar",3,2799);
				string_value();
				wsdl_AST = (AST)returnAST;
				AST tmp134_AST = null;
				tmp134_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"evar",4,2804);
				match(COMMA);
				bShouldFire=aboutToEnter(bShouldFire,"evar",5,2806);
				string_value();
				wm_AST = (AST)returnAST;
				AST tmp135_AST = null;
				tmp135_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"evar",6,2811);
				match(COMMA);
				bShouldFire=aboutToEnter(bShouldFire,"evar",7,2813);
				string_value();
				ins_AST = (AST)returnAST;
				AST tmp136_AST = null;
				tmp136_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"evar",8,2818);
				match(COMMA);
				bShouldFire=aboutToEnter(bShouldFire,"evar",9,2820);
				xpath_expression();
				outs_AST = (AST)returnAST;
				AST tmp137_AST = null;
				tmp137_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"evar",10,2825);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					evar_AST = (AST)currentAST.root;
					
							evar_AST = (AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(EXTERNAL_VARIABLE,"ExtVar","it.polimi.monitor.nodes.ExtVarNode")).add((AST)astFactory.make( (new ASTArray(5)).add(r_AST).add(wsdl_AST).add(wm_AST).add(ins_AST).add(outs_AST)))); 
						
					currentAST.root = evar_AST;
					currentAST.child = evar_AST!=null &&evar_AST.getFirstChild()!=null ?
						evar_AST.getFirstChild() : evar_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_26);
				} else {
				  throw ex;
				}
			}
			returnAST = evar_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void hvar() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("hvar");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST hvar_AST = null;
			AST p_AST = null;
			AST u_AST = null;
			Token  i = null;
			AST i_AST = null;
			AST l_AST = null;
			Token  ass = null;
			it.polimi.monitor.nodes.SimpleAST ass_AST = null;
			Token  al = null;
			it.polimi.monitor.nodes.SimpleAST al_AST = null;
			Token  n = null;
			it.polimi.monitor.nodes.SimpleAST n_AST = null;
			
			try {      // for error handling
				AST tmp138_AST = null;
				tmp138_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"hvar",1,2878);
				match(KW_RETRIEVE);
				AST tmp139_AST = null;
				tmp139_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"hvar",2,2882);
				match(LEFT_PAREN);
				bShouldFire=aboutToEnter(bShouldFire,"hvar",3,2884);
				string_value();
				p_AST = (AST)returnAST;
				{
				if ((LA(1)==COMMA) && (_tokenSet_23.member(LA(2))) && (_tokenSet_35.member(LA(3))) && (_tokenSet_36.member(LA(4)))) {
					AST tmp140_AST = null;
					tmp140_AST = astFactory.create(LT(1));
					bShouldFire=aboutToEnter(bShouldFire,"hvar",4,2891);
					match(COMMA);
					bShouldFire=aboutToEnter(bShouldFire,"hvar",5,2893);
					string_value();
					u_AST = (AST)returnAST;
				}
				else if ((LA(1)==COMMA) && (_tokenSet_30.member(LA(2))) && (_tokenSet_37.member(LA(3))) && (_tokenSet_38.member(LA(4)))) {
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				{
				if ((LA(1)==COMMA) && (LA(2)==NUMBER) && (LA(3)==COMMA) && (_tokenSet_30.member(LA(4)))) {
					AST tmp141_AST = null;
					tmp141_AST = astFactory.create(LT(1));
					bShouldFire=aboutToEnter(bShouldFire,"hvar",6,2908);
					match(COMMA);
					i = LT(1);
					i_AST = astFactory.create(i);
					bShouldFire=aboutToEnter(bShouldFire,"hvar",7,2912);
					match(NUMBER);
				}
				else if ((LA(1)==COMMA) && (_tokenSet_30.member(LA(2))) && (_tokenSet_37.member(LA(3))) && (_tokenSet_38.member(LA(4)))) {
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				AST tmp142_AST = null;
				tmp142_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"hvar",8,2924);
				match(COMMA);
				bShouldFire=aboutToEnter(bShouldFire,"hvar",9,2926);
				xpath_expression();
				l_AST = (AST)returnAST;
				AST tmp143_AST = null;
				tmp143_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"hvar",10,2931);
				match(COMMA);
				ass = LT(1);
				ass_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(ass,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"hvar",11,2935);
				match(NUMBER);
				AST tmp144_AST = null;
				tmp144_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"hvar",12,2939);
				match(COMMA);
				AST tmp145_AST = null;
				tmp145_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"hvar",13,2943);
				match(DOLLAR_SIGN);
				al = LT(1);
				al_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(al,"it.polimi.monitor.nodes.SimpleAST");
				bShouldFire=aboutToEnter(bShouldFire,"hvar",14,2947);
				match(IDENTIFIER);
				{
				switch ( LA(1)) {
				case COMMA:
				{
					AST tmp146_AST = null;
					tmp146_AST = astFactory.create(LT(1));
					bShouldFire=aboutToEnter(bShouldFire,"hvar",15,2955);
					match(COMMA);
					n = LT(1);
					n_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(n,"it.polimi.monitor.nodes.SimpleAST");
					bShouldFire=aboutToEnter(bShouldFire,"hvar",16,2959);
					match(NUMBER);
					break;
				}
				case RIGHT_PAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				AST tmp147_AST = null;
				tmp147_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"hvar",17,2975);
				match(RIGHT_PAREN);
				if ( inputState.guessing==0 ) {
					hvar_AST = (AST)currentAST.root;
					
							hvar_AST = (AST)astFactory.make( (new ASTArray(8)).add((AST)astFactory.create(RETRIEVE,"Retrieve","it.polimi.monitor.nodes.RetrieveNode")).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(PROCESS_ID,"Process_ID","it.polimi.monitor.nodes.ProcessIdNode")).add(p_AST))).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(USER_ID,"User_ID","it.polimi.monitor.nodes.UserIdNode")).add(u_AST))).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(INSTANCE_ID,"Instance_ID","it.polimi.monitor.nodes.InstanceIdNode")).add(i_AST))).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(LOCATION,"Location","it.polimi.monitor.nodes.LocationNode")).add(l_AST))).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(ASSERTION_TYPE,"Assertion_Type","it.polimi.monitor.nodes.AssertionTypeNode")).add(ass_AST))).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(HISTORICAL_VARIABLE,"H_VAR","it.polimi.monitor.nodes.AliasNameNode")).add(al_AST))).add((AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(NUMBER_OF_RESULTS,"Number_Of_Result","it.polimi.monitor.nodes.NumMaxResultsNode")).add(n_AST))));
						
					currentAST.root = hvar_AST;
					currentAST.child = hvar_AST!=null &&hvar_AST.getFirstChild()!=null ?
						hvar_AST.getFirstChild() : hvar_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_26);
				} else {
				  throw ex;
				}
			}
			returnAST = hvar_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void xpath_expression() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("xpath_expression");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST xpath_expression_AST = null;
			AST u_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"xpath_expression",1,3016);
				union_expr();
				u_AST = (AST)returnAST;
				if ( inputState.guessing==0 ) {
					xpath_expression_AST = (AST)currentAST.root;
					
							xpath_expression_AST = (AST)astFactory.make( (new ASTArray(2)).add((AST)astFactory.create(XPATH,"XPath_Expression","it.polimi.monitor.nodes.XPath_ExpressionNode")).add(u_AST)); 
						
					currentAST.root = xpath_expression_AST;
					currentAST.child = xpath_expression_AST!=null &&xpath_expression_AST.getFirstChild()!=null ?
						xpath_expression_AST.getFirstChild() : xpath_expression_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_26);
				} else {
				  throw ex;
				}
			}
			returnAST = xpath_expression_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void returnType() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("returnType");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST returnType_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case KW_RETURN_NUMBER:
				{
					AST tmp148_AST = null;
					tmp148_AST = astFactory.create(LT(1));
					bShouldFire=aboutToEnter(bShouldFire,"returnType",1,3062);
					match(KW_RETURN_NUMBER);
					if ( inputState.guessing==0 ) {
						returnType_AST = (AST)currentAST.root;
						returnType_AST=(AST)astFactory.make( (new ASTArray(1)).add(astFactory.create(RETURN_NUMBER,"RETURN_NUMBER")));
						currentAST.root = returnType_AST;
						currentAST.child = returnType_AST!=null &&returnType_AST.getFirstChild()!=null ?
							returnType_AST.getFirstChild() : returnType_AST;
						currentAST.advanceChildToEnd();
					}
					break;
				}
				case KW_RETURN_BOOL:
				{
					AST tmp149_AST = null;
					tmp149_AST = astFactory.create(LT(1));
					bShouldFire=aboutToEnter(bShouldFire,"returnType",2,3078);
					match(KW_RETURN_BOOL);
					if ( inputState.guessing==0 ) {
						returnType_AST = (AST)currentAST.root;
						returnType_AST=(AST)astFactory.make( (new ASTArray(1)).add(astFactory.create(RETURN_BOOL,"RETURN_BOOL")));
						currentAST.root = returnType_AST;
						currentAST.child = returnType_AST!=null &&returnType_AST.getFirstChild()!=null ?
							returnType_AST.getFirstChild() : returnType_AST;
						currentAST.advanceChildToEnd();
					}
					break;
				}
				case KW_RETURN_STRING:
				{
					AST tmp150_AST = null;
					tmp150_AST = astFactory.create(LT(1));
					bShouldFire=aboutToEnter(bShouldFire,"returnType",3,3094);
					match(KW_RETURN_STRING);
					if ( inputState.guessing==0 ) {
						returnType_AST = (AST)currentAST.root;
						returnType_AST=(AST)astFactory.make( (new ASTArray(1)).add(astFactory.create(RETURN_STRING,"RETURN_STRING")));
						currentAST.root = returnType_AST;
						currentAST.child = returnType_AST!=null &&returnType_AST.getFirstChild()!=null ?
							returnType_AST.getFirstChild() : returnType_AST;
						currentAST.advanceChildToEnd();
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_39);
				} else {
				  throw ex;
				}
			}
			returnAST = returnType_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void alias() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("alias");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST alias_AST = null;
			Token  v = null;
			AST v_AST = null;
			
			try {      // for error handling
				AST tmp151_AST = null;
				tmp151_AST = astFactory.create(LT(1));
				bShouldFire=aboutToEnter(bShouldFire,"alias",1,3143);
				match(DOLLAR_SIGN);
				v = LT(1);
				v_AST = astFactory.create(v);
				bShouldFire=aboutToEnter(bShouldFire,"alias",2,3147);
				match(IDENTIFIER);
				if ( inputState.guessing==0 ) {
					alias_AST = (AST)currentAST.root;
					
							alias_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ALIAS,"Alias")).add(v_AST)); 
						
					currentAST.root = alias_AST;
					currentAST.child = alias_AST!=null &&alias_AST.getFirstChild()!=null ?
						alias_AST.getFirstChild() : alias_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = alias_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void sub_string_value() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("sub_string_value");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST sub_string_value_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case IDENTIFIER:
				{
					it.polimi.monitor.nodes.StringAST tmp152_AST = null;
					tmp152_AST = (it.polimi.monitor.nodes.StringAST)astFactory.create(LT(1),"it.polimi.monitor.nodes.StringAST");
					astFactory.addASTChild(currentAST, tmp152_AST);
					bShouldFire=aboutToEnter(bShouldFire,"sub_string_value",1,3193);
					match(IDENTIFIER);
					sub_string_value_AST = (AST)currentAST.root;
					break;
				}
				case LITERAL:
				{
					it.polimi.monitor.nodes.StringAST tmp153_AST = null;
					tmp153_AST = (it.polimi.monitor.nodes.StringAST)astFactory.create(LT(1),"it.polimi.monitor.nodes.StringAST");
					astFactory.addASTChild(currentAST, tmp153_AST);
					bShouldFire=aboutToEnter(bShouldFire,"sub_string_value",2,3203);
					match(LITERAL);
					sub_string_value_AST = (AST)currentAST.root;
					break;
				}
				case KW_RETRIEVE:
				case KW_RETURN_NUMBER:
				case KW_RETURN_BOOL:
				case KW_RETURN_STRING:
				case LEFT_PAREN:
				case DOLLAR_SIGN:
				{
					bShouldFire=aboutToEnter(bShouldFire,"sub_string_value",3,3215);
					variable();
					astFactory.addASTChild(currentAST, returnAST);
					sub_string_value_AST = (AST)currentAST.root;
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_29);
				} else {
				  throw ex;
				}
			}
			returnAST = sub_string_value_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void serialized() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("serialized");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST serialized_AST = null;
			AST s1_AST = null;
			AST s2_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"serialized",1,3256);
				string_value();
				s1_AST = (AST)returnAST;
				{
				_loop1016:
				do {
					if ((LA(1)==PIPE)) {
						AST tmp154_AST = null;
						tmp154_AST = astFactory.create(LT(1));
						bShouldFire=aboutToEnter(bShouldFire,"serialized",2,3265);
						match(PIPE);
						bShouldFire=aboutToEnter(bShouldFire,"serialized",3,3267);
						string_value();
						s2_AST = (AST)returnAST;
					}
					else {
						break _loop1016;
					}
					
				} while (true);
				}
				if ( inputState.guessing==0 ) {
					serialized_AST = (AST)currentAST.root;
					
							serialized_AST = (AST)astFactory.make( (new ASTArray(3)).add(astFactory.create(SERIES,"Series")).add(s1_AST).add(s2_AST));
						
					currentAST.root = serialized_AST;
					currentAST.child = serialized_AST!=null &&serialized_AST.getFirstChild()!=null ?
						serialized_AST.getFirstChild() : serialized_AST;
					currentAST.advanceChildToEnd();
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = serialized_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void union_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("union_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST union_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"union_expr",1,3315);
				path_expr();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop1065:
				do {
					if ((LA(1)==PIPE) && (_tokenSet_30.member(LA(2))) && (_tokenSet_40.member(LA(3))) && (_tokenSet_41.member(LA(4)))) {
						bShouldFire=aboutToEnter(bShouldFire,"union_expr",2,3322);
						match(PIPE);
						bShouldFire=aboutToEnter(bShouldFire,"union_expr",3,3324);
						path_expr();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop1065;
					}
					
				} while (true);
				}
				union_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_42);
				} else {
				  throw ex;
				}
			}
			returnAST = union_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void location_path() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("location_path");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST location_path_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case SLASH:
				case DOUBLE_SLASH:
				{
					bShouldFire=aboutToEnter(bShouldFire,"location_path",1,3367);
					absolute_location_path();
					astFactory.addASTChild(currentAST, returnAST);
					location_path_AST = (AST)currentAST.root;
					break;
				}
				case IDENTIFIER:
				case DOT:
				case DOT_DOT:
				case AT:
				case STAR:
				{
					bShouldFire=aboutToEnter(bShouldFire,"location_path",2,3379);
					relative_location_path();
					astFactory.addASTChild(currentAST, returnAST);
					location_path_AST = (AST)currentAST.root;
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_42);
				} else {
				  throw ex;
				}
			}
			returnAST = location_path_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void absolute_location_path() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("absolute_location_path");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST absolute_location_path_AST = null;
			
			try {      // for error handling
				{
				switch ( LA(1)) {
				case SLASH:
				{
					it.polimi.monitor.nodes.SLASHNode tmp156_AST = null;
					tmp156_AST = (it.polimi.monitor.nodes.SLASHNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.SLASHNode");
					astFactory.makeASTRoot(currentAST, tmp156_AST);
					bShouldFire=aboutToEnter(bShouldFire,"absolute_location_path",1,3425);
					match(SLASH);
					break;
				}
				case DOUBLE_SLASH:
				{
					AST tmp157_AST = null;
					tmp157_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp157_AST);
					bShouldFire=aboutToEnter(bShouldFire,"absolute_location_path",2,3434);
					match(DOUBLE_SLASH);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				{
				boolean synPredMatched1023 = false;
				if (((_tokenSet_43.member(LA(1))) && (_tokenSet_44.member(LA(2))) && (_tokenSet_45.member(LA(3))) && (_tokenSet_33.member(LA(4))))) {
					int _m1023 = mark();
					synPredMatched1023 = true;
					inputState.guessing++;
					try {
						{
						switch ( LA(1)) {
						case AT:
						{
							bShouldFire=aboutToEnter(bShouldFire,"absolute_location_path",3,3455);
							match(AT);
							break;
						}
						case STAR:
						{
							bShouldFire=aboutToEnter(bShouldFire,"absolute_location_path",4,3461);
							match(STAR);
							break;
						}
						case IDENTIFIER:
						{
							bShouldFire=aboutToEnter(bShouldFire,"absolute_location_path",5,3467);
							match(IDENTIFIER);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
					}
					catch (RecognitionException pe) {
						synPredMatched1023 = false;
					}
					rewind(_m1023);
inputState.guessing--;
				}
				if ( synPredMatched1023 ) {
					bShouldFire=aboutToEnter(bShouldFire,"absolute_location_path",6,3485);
					i_relative_location_path();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else if ((_tokenSet_42.member(LA(1))) && (_tokenSet_46.member(LA(2))) && (_tokenSet_33.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
				}
				absolute_location_path_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_42);
				} else {
				  throw ex;
				}
			}
			returnAST = absolute_location_path_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void relative_location_path() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("relative_location_path");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST relative_location_path_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"relative_location_path",1,3525);
				i_relative_location_path();
				astFactory.addASTChild(currentAST, returnAST);
				relative_location_path_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_42);
				} else {
				  throw ex;
				}
			}
			returnAST = relative_location_path_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void i_relative_location_path() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("i_relative_location_path");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST i_relative_location_path_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"i_relative_location_path",1,3557);
				step();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop1028:
				do {
					if ((LA(1)==SLASH||LA(1)==DOUBLE_SLASH) && (_tokenSet_43.member(LA(2))) && (_tokenSet_44.member(LA(3))) && (_tokenSet_45.member(LA(4)))) {
						{
						switch ( LA(1)) {
						case SLASH:
						{
							it.polimi.monitor.nodes.SLASHNode tmp158_AST = null;
							tmp158_AST = (it.polimi.monitor.nodes.SLASHNode)astFactory.create(LT(1),"it.polimi.monitor.nodes.SLASHNode");
							astFactory.makeASTRoot(currentAST, tmp158_AST);
							bShouldFire=aboutToEnter(bShouldFire,"i_relative_location_path",2,3571);
							match(SLASH);
							break;
						}
						case DOUBLE_SLASH:
						{
							AST tmp159_AST = null;
							tmp159_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp159_AST);
							bShouldFire=aboutToEnter(bShouldFire,"i_relative_location_path",3,3580);
							match(DOUBLE_SLASH);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						bShouldFire=aboutToEnter(bShouldFire,"i_relative_location_path",4,3590);
						step();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop1028;
					}
					
				} while (true);
				}
				i_relative_location_path_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_42);
				} else {
				  throw ex;
				}
			}
			returnAST = i_relative_location_path_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void step() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("step");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST step_AST = null;
			Token  ns = null;
			AST ns_AST = null;
			Token  id = null;
			it.polimi.monitor.nodes.SimpleAST id_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case IDENTIFIER:
				case AT:
				case STAR:
				{
					{
					{
					boolean synPredMatched1033 = false;
					if (((LA(1)==IDENTIFIER||LA(1)==AT) && (LA(2)==IDENTIFIER||LA(2)==DOUBLE_COLON||LA(2)==STAR) && (_tokenSet_47.member(LA(3))) && (_tokenSet_45.member(LA(4))))) {
						int _m1033 = mark();
						synPredMatched1033 = true;
						inputState.guessing++;
						try {
							{
							switch ( LA(1)) {
							case IDENTIFIER:
							{
								bShouldFire=aboutToEnter(bShouldFire,"step",1,3650);
								match(IDENTIFIER);
								bShouldFire=aboutToEnter(bShouldFire,"step",2,3652);
								match(DOUBLE_COLON);
								break;
							}
							case AT:
							{
								bShouldFire=aboutToEnter(bShouldFire,"step",3,3658);
								match(AT);
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							}
							}
						}
						catch (RecognitionException pe) {
							synPredMatched1033 = false;
						}
						rewind(_m1033);
inputState.guessing--;
					}
					if ( synPredMatched1033 ) {
						bShouldFire=aboutToEnter(bShouldFire,"step",4,3676);
						axis();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else if ((LA(1)==IDENTIFIER||LA(1)==STAR) && (_tokenSet_48.member(LA(2))) && (_tokenSet_46.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
					}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					
					}
					{
					if ((LA(1)==IDENTIFIER||LA(1)==STAR) && (_tokenSet_49.member(LA(2)))) {
						{
						{
						{
						if ((LA(1)==IDENTIFIER) && (LA(2)==COLON)) {
							ns = LT(1);
							ns_AST = astFactory.create(ns);
							astFactory.addASTChild(currentAST, ns_AST);
							bShouldFire=aboutToEnter(bShouldFire,"step",5,3696);
							match(IDENTIFIER);
							AST tmp160_AST = null;
							tmp160_AST = astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp160_AST);
							bShouldFire=aboutToEnter(bShouldFire,"step",6,3701);
							match(COLON);
						}
						else if ((LA(1)==IDENTIFIER||LA(1)==STAR) && (_tokenSet_50.member(LA(2)))) {
						}
						else {
							throw new NoViableAltException(LT(1), getFilename());
						}
						
						}
						{
						switch ( LA(1)) {
						case IDENTIFIER:
						{
							id = LT(1);
							id_AST = (it.polimi.monitor.nodes.SimpleAST)astFactory.create(id,"it.polimi.monitor.nodes.SimpleAST");
							astFactory.addASTChild(currentAST, id_AST);
							bShouldFire=aboutToEnter(bShouldFire,"step",7,3718);
							match(IDENTIFIER);
							break;
						}
						case STAR:
						{
							AST tmp161_AST = null;
							tmp161_AST = astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp161_AST);
							bShouldFire=aboutToEnter(bShouldFire,"step",8,3727);
							match(STAR);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						}
						}
					}
					else if ((LA(1)==IDENTIFIER) && (LA(2)==LEFT_PAREN)) {
						bShouldFire=aboutToEnter(bShouldFire,"step",9,3741);
						special_step();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					
					}
					{
					_loop1040:
					do {
						if ((LA(1)==LEFT_BRACKET)) {
							bShouldFire=aboutToEnter(bShouldFire,"step",10,3754);
							predicate();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop1040;
						}
						
					} while (true);
					}
					}
					step_AST = (AST)currentAST.root;
					break;
				}
				case DOT:
				case DOT_DOT:
				{
					bShouldFire=aboutToEnter(bShouldFire,"step",11,3771);
					abbr_step();
					astFactory.addASTChild(currentAST, returnAST);
					{
					_loop1042:
					do {
						if ((LA(1)==LEFT_BRACKET)) {
							bShouldFire=aboutToEnter(bShouldFire,"step",12,3778);
							predicate();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop1042;
						}
						
					} while (true);
					}
					step_AST = (AST)currentAST.root;
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_51);
				} else {
				  throw ex;
				}
			}
			returnAST = step_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void axis() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("axis");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST axis_AST = null;
			Token  id = null;
			AST id_AST = null;
			
			try {      // for error handling
				{
				switch ( LA(1)) {
				case IDENTIFIER:
				{
					id = LT(1);
					id_AST = astFactory.create(id);
					astFactory.addASTChild(currentAST, id_AST);
					bShouldFire=aboutToEnter(bShouldFire,"axis",1,3833);
					match(IDENTIFIER);
					AST tmp162_AST = null;
					tmp162_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp162_AST);
					bShouldFire=aboutToEnter(bShouldFire,"axis",2,3838);
					match(DOUBLE_COLON);
					break;
				}
				case AT:
				{
					AST tmp163_AST = null;
					tmp163_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp163_AST);
					bShouldFire=aboutToEnter(bShouldFire,"axis",3,3847);
					match(AT);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				axis_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_52);
				} else {
				  throw ex;
				}
			}
			returnAST = axis_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void special_step() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("special_step");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST special_step_AST = null;
			
			try {      // for error handling
				if (((LA(1)==IDENTIFIER) && (LA(2)==LEFT_PAREN) && (LA(3)==IDENTIFIER||LA(3)==RIGHT_PAREN) && (_tokenSet_50.member(LA(4))))&&(
		LT(1).getText().equals("processing-instruction")
	)) {
					AST tmp164_AST = null;
					tmp164_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp164_AST);
					bShouldFire=aboutToEnter(bShouldFire,"special_step",1,3892);
					match(IDENTIFIER);
					AST tmp165_AST = null;
					tmp165_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp165_AST);
					bShouldFire=aboutToEnter(bShouldFire,"special_step",2,3897);
					match(LEFT_PAREN);
					{
					switch ( LA(1)) {
					case IDENTIFIER:
					{
						AST tmp166_AST = null;
						tmp166_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp166_AST);
						bShouldFire=aboutToEnter(bShouldFire,"special_step",3,3906);
						match(IDENTIFIER);
						break;
					}
					case RIGHT_PAREN:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					AST tmp167_AST = null;
					tmp167_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp167_AST);
					bShouldFire=aboutToEnter(bShouldFire,"special_step",4,3923);
					match(RIGHT_PAREN);
					special_step_AST = (AST)currentAST.root;
				}
				else if (((LA(1)==IDENTIFIER) && (LA(2)==LEFT_PAREN) && (LA(3)==RIGHT_PAREN) && (_tokenSet_50.member(LA(4))))&&(
		LT(1).getText().equals("comment")
			||	LT(1).getText().equals("text")
			||	LT(1).getText().equals("node")
	)) {
					AST tmp168_AST = null;
					tmp168_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp168_AST);
					bShouldFire=aboutToEnter(bShouldFire,"special_step",5,3935);
					match(IDENTIFIER);
					AST tmp169_AST = null;
					tmp169_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp169_AST);
					bShouldFire=aboutToEnter(bShouldFire,"special_step",6,3940);
					match(LEFT_PAREN);
					AST tmp170_AST = null;
					tmp170_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp170_AST);
					bShouldFire=aboutToEnter(bShouldFire,"special_step",7,3945);
					match(RIGHT_PAREN);
					special_step_AST = (AST)currentAST.root;
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_50);
				} else {
				  throw ex;
				}
			}
			returnAST = special_step_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void predicate() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("predicate");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST predicate_AST = null;
			
			try {      // for error handling
				AST tmp171_AST = null;
				tmp171_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp171_AST);
				bShouldFire=aboutToEnter(bShouldFire,"predicate",1,3984);
				match(LEFT_BRACKET);
				bShouldFire=aboutToEnter(bShouldFire,"predicate",2,3986);
				predicate_expr();
				astFactory.addASTChild(currentAST, returnAST);
				bShouldFire=aboutToEnter(bShouldFire,"predicate",3,3989);
				match(RIGHT_BRACKET);
				predicate_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_50);
				} else {
				  throw ex;
				}
			}
			returnAST = predicate_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void abbr_step() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("abbr_step");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST abbr_step_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case DOT:
				{
					AST tmp173_AST = null;
					tmp173_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp173_AST);
					bShouldFire=aboutToEnter(bShouldFire,"abbr_step",1,4026);
					match(DOT);
					abbr_step_AST = (AST)currentAST.root;
					break;
				}
				case DOT_DOT:
				{
					AST tmp174_AST = null;
					tmp174_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp174_AST);
					bShouldFire=aboutToEnter(bShouldFire,"abbr_step",2,4036);
					match(DOT_DOT);
					abbr_step_AST = (AST)currentAST.root;
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_50);
				} else {
				  throw ex;
				}
			}
			returnAST = abbr_step_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void predicate_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("predicate_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST predicate_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"predicate_expr",1,4074);
				expr();
				astFactory.addASTChild(currentAST, returnAST);
				predicate_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_53);
				} else {
				  throw ex;
				}
			}
			returnAST = predicate_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"expr",1,4106);
				or_expr();
				astFactory.addASTChild(currentAST, returnAST);
				expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_54);
				} else {
				  throw ex;
				}
			}
			returnAST = expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void abbr_axis_specifier() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("abbr_axis_specifier");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST abbr_axis_specifier_AST = null;
			
			try {      // for error handling
				{
				switch ( LA(1)) {
				case AT:
				{
					AST tmp175_AST = null;
					tmp175_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp175_AST);
					bShouldFire=aboutToEnter(bShouldFire,"abbr_axis_specifier",1,4145);
					match(AT);
					break;
				}
				case EOF:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				abbr_axis_specifier_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = abbr_axis_specifier_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void or_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("or_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST or_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"or_expr",1,4188);
				and_expr();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop1080:
				do {
					if ((LA(1)==KW_OR)) {
						AST tmp176_AST = null;
						tmp176_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp176_AST);
						bShouldFire=aboutToEnter(bShouldFire,"or_expr",2,4198);
						match(KW_OR);
						bShouldFire=aboutToEnter(bShouldFire,"or_expr",3,4200);
						and_expr();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop1080;
					}
					
				} while (true);
				}
				or_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_54);
				} else {
				  throw ex;
				}
			}
			returnAST = or_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void primary_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("primary_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST primary_expr_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case DOLLAR_SIGN:
				{
					bShouldFire=aboutToEnter(bShouldFire,"primary_expr",1,4242);
					variable_reference();
					astFactory.addASTChild(currentAST, returnAST);
					primary_expr_AST = (AST)currentAST.root;
					break;
				}
				case LEFT_PAREN:
				{
					bShouldFire=aboutToEnter(bShouldFire,"primary_expr",2,4250);
					match(LEFT_PAREN);
					bShouldFire=aboutToEnter(bShouldFire,"primary_expr",3,4252);
					expr();
					astFactory.addASTChild(currentAST, returnAST);
					bShouldFire=aboutToEnter(bShouldFire,"primary_expr",4,4255);
					match(RIGHT_PAREN);
					primary_expr_AST = (AST)currentAST.root;
					break;
				}
				case LITERAL:
				{
					bShouldFire=aboutToEnter(bShouldFire,"primary_expr",5,4262);
					literal();
					astFactory.addASTChild(currentAST, returnAST);
					primary_expr_AST = (AST)currentAST.root;
					break;
				}
				case NUMBER:
				{
					bShouldFire=aboutToEnter(bShouldFire,"primary_expr",6,4270);
					number();
					astFactory.addASTChild(currentAST, returnAST);
					primary_expr_AST = (AST)currentAST.root;
					break;
				}
				case IDENTIFIER:
				{
					bShouldFire=aboutToEnter(bShouldFire,"primary_expr",7,4278);
					function_call();
					astFactory.addASTChild(currentAST, returnAST);
					primary_expr_AST = (AST)currentAST.root;
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_50);
				} else {
				  throw ex;
				}
			}
			returnAST = primary_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void variable_reference() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("variable_reference");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST variable_reference_AST = null;
			
			try {      // for error handling
				AST tmp179_AST = null;
				tmp179_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp179_AST);
				bShouldFire=aboutToEnter(bShouldFire,"variable_reference",1,4320);
				match(DOLLAR_SIGN);
				AST tmp180_AST = null;
				tmp180_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp180_AST);
				bShouldFire=aboutToEnter(bShouldFire,"variable_reference",2,4325);
				match(IDENTIFIER);
				variable_reference_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_50);
				} else {
				  throw ex;
				}
			}
			returnAST = variable_reference_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void literal() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("literal");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST literal_AST = null;
			Token  lit = null;
			AST lit_AST = null;
			
			try {      // for error handling
				lit = LT(1);
				lit_AST = astFactory.create(lit);
				astFactory.makeASTRoot(currentAST, lit_AST);
				bShouldFire=aboutToEnter(bShouldFire,"literal",1,4361);
				match(LITERAL);
				literal_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_50);
				} else {
				  throw ex;
				}
			}
			returnAST = literal_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void number() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("number");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST number_AST = null;
			
			try {      // for error handling
				AST tmp181_AST = null;
				tmp181_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp181_AST);
				bShouldFire=aboutToEnter(bShouldFire,"number",1,4395);
				match(NUMBER);
				number_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_50);
				} else {
				  throw ex;
				}
			}
			returnAST = number_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void function_call() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("function_call");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST function_call_AST = null;
			
			try {      // for error handling
				AST tmp182_AST = null;
				tmp182_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp182_AST);
				bShouldFire=aboutToEnter(bShouldFire,"function_call",1,4429);
				match(IDENTIFIER);
				AST tmp183_AST = null;
				tmp183_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp183_AST);
				bShouldFire=aboutToEnter(bShouldFire,"function_call",2,4434);
				match(LEFT_PAREN);
				{
				switch ( LA(1)) {
				case LITERAL:
				case NUMBER:
				case IDENTIFIER:
				case LEFT_PAREN:
				case DOT:
				case DOT_DOT:
				case AT:
				case SLASH:
				case DOUBLE_SLASH:
				case DOLLAR_SIGN:
				case MINUS:
				case STAR:
				{
					bShouldFire=aboutToEnter(bShouldFire,"function_call",3,4451);
					arg_list();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case RIGHT_PAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				bShouldFire=aboutToEnter(bShouldFire,"function_call",4,4466);
				match(RIGHT_PAREN);
				function_call_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_50);
				} else {
				  throw ex;
				}
			}
			returnAST = function_call_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void arg_list() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("arg_list");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST arg_list_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"arg_list",1,4497);
				argument();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop1061:
				do {
					if ((LA(1)==COMMA)) {
						AST tmp185_AST = null;
						tmp185_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp185_AST);
						bShouldFire=aboutToEnter(bShouldFire,"arg_list",2,4507);
						match(COMMA);
						bShouldFire=aboutToEnter(bShouldFire,"arg_list",3,4509);
						argument();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop1061;
					}
					
				} while (true);
				}
				arg_list_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_8);
				} else {
				  throw ex;
				}
			}
			returnAST = arg_list_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void argument() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("argument");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST argument_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"argument",1,4548);
				expr();
				astFactory.addASTChild(currentAST, returnAST);
				argument_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_55);
				} else {
				  throw ex;
				}
			}
			returnAST = argument_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void path_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("path_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST path_expr_AST = null;
			
			try {      // for error handling
				boolean synPredMatched1068 = false;
				if ((((_tokenSet_56.member(LA(1))) && (_tokenSet_57.member(LA(2))) && (_tokenSet_41.member(LA(3))) && (_tokenSet_33.member(LA(4))))&&( LT(1).getText().equals("processing-instruction")
		||	LT(1).getText().equals("comment")
		||  LT(1).getText().equals("text")
		||  LT(1).getText().equals("node")
	))) {
					int _m1068 = mark();
					synPredMatched1068 = true;
					inputState.guessing++;
					try {
						{
						bShouldFire=aboutToEnter(bShouldFire,"path_expr",1,4591);
						match(IDENTIFIER);
						bShouldFire=aboutToEnter(bShouldFire,"path_expr",2,4593);
						match(LEFT_PAREN);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched1068 = false;
					}
					rewind(_m1068);
inputState.guessing--;
				}
				if ( synPredMatched1068 ) {
					bShouldFire=aboutToEnter(bShouldFire,"path_expr",3,4604);
					location_path();
					astFactory.addASTChild(currentAST, returnAST);
					path_expr_AST = (AST)currentAST.root;
				}
				else {
					boolean synPredMatched1070 = false;
					if (((_tokenSet_58.member(LA(1))) && (_tokenSet_59.member(LA(2))) && (_tokenSet_41.member(LA(3))) && (_tokenSet_33.member(LA(4))))) {
						int _m1070 = mark();
						synPredMatched1070 = true;
						inputState.guessing++;
						try {
							{
							bShouldFire=aboutToEnter(bShouldFire,"path_expr",4,4617);
							match(IDENTIFIER);
							bShouldFire=aboutToEnter(bShouldFire,"path_expr",5,4619);
							match(LEFT_PAREN);
							}
						}
						catch (RecognitionException pe) {
							synPredMatched1070 = false;
						}
						rewind(_m1070);
inputState.guessing--;
					}
					if ( synPredMatched1070 ) {
						bShouldFire=aboutToEnter(bShouldFire,"path_expr",6,4630);
						filter_expr();
						astFactory.addASTChild(currentAST, returnAST);
						{
						if ((LA(1)==SLASH||LA(1)==DOUBLE_SLASH) && (_tokenSet_60.member(LA(2))) && (_tokenSet_41.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
							bShouldFire=aboutToEnter(bShouldFire,"path_expr",7,4635);
							absolute_location_path();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else if ((_tokenSet_42.member(LA(1))) && (_tokenSet_46.member(LA(2))) && (_tokenSet_33.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
						}
						else {
							throw new NoViableAltException(LT(1), getFilename());
						}
						
						}
						path_expr_AST = (AST)currentAST.root;
					}
					else {
						boolean synPredMatched1073 = false;
						if (((_tokenSet_56.member(LA(1))) && (_tokenSet_57.member(LA(2))) && (_tokenSet_41.member(LA(3))) && (_tokenSet_33.member(LA(4))))) {
							int _m1073 = mark();
							synPredMatched1073 = true;
							inputState.guessing++;
							try {
								{
								switch ( LA(1)) {
								case DOT:
								{
									bShouldFire=aboutToEnter(bShouldFire,"path_expr",8,4659);
									match(DOT);
									break;
								}
								case DOT_DOT:
								{
									bShouldFire=aboutToEnter(bShouldFire,"path_expr",9,4665);
									match(DOT_DOT);
									break;
								}
								case SLASH:
								{
									bShouldFire=aboutToEnter(bShouldFire,"path_expr",10,4671);
									match(SLASH);
									break;
								}
								case DOUBLE_SLASH:
								{
									bShouldFire=aboutToEnter(bShouldFire,"path_expr",11,4677);
									match(DOUBLE_SLASH);
									break;
								}
								case IDENTIFIER:
								{
									bShouldFire=aboutToEnter(bShouldFire,"path_expr",12,4683);
									match(IDENTIFIER);
									break;
								}
								case AT:
								{
									bShouldFire=aboutToEnter(bShouldFire,"path_expr",13,4689);
									match(AT);
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1), getFilename());
								}
								}
								}
							}
							catch (RecognitionException pe) {
								synPredMatched1073 = false;
							}
							rewind(_m1073);
inputState.guessing--;
						}
						if ( synPredMatched1073 ) {
							bShouldFire=aboutToEnter(bShouldFire,"path_expr",14,4707);
							location_path();
							astFactory.addASTChild(currentAST, returnAST);
							path_expr_AST = (AST)currentAST.root;
						}
						else if ((_tokenSet_58.member(LA(1))) && (_tokenSet_59.member(LA(2))) && (_tokenSet_41.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
							bShouldFire=aboutToEnter(bShouldFire,"path_expr",15,4713);
							filter_expr();
							astFactory.addASTChild(currentAST, returnAST);
							{
							if ((LA(1)==SLASH||LA(1)==DOUBLE_SLASH) && (_tokenSet_60.member(LA(2))) && (_tokenSet_41.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
								bShouldFire=aboutToEnter(bShouldFire,"path_expr",16,4718);
								absolute_location_path();
								astFactory.addASTChild(currentAST, returnAST);
							}
							else if ((_tokenSet_42.member(LA(1))) && (_tokenSet_46.member(LA(2))) && (_tokenSet_33.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
							}
							else {
								throw new NoViableAltException(LT(1), getFilename());
							}
							
							}
							path_expr_AST = (AST)currentAST.root;
						}
						else {
							throw new NoViableAltException(LT(1), getFilename());
						}
						}}
					}
					catch (RecognitionException ex) {
						if (inputState.guessing==0) {
							reportError(ex);
							recover(ex,_tokenSet_42);
						} else {
						  throw ex;
						}
					}
					returnAST = path_expr_AST;
				} finally { // debugging
					exitRule();
				}
			}
			
	public final void filter_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("filter_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST filter_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"filter_expr",1,4763);
				primary_expr();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop1077:
				do {
					if ((LA(1)==LEFT_BRACKET)) {
						bShouldFire=aboutToEnter(bShouldFire,"filter_expr",2,4770);
						predicate();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop1077;
					}
					
				} while (true);
				}
				filter_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_51);
				} else {
				  throw ex;
				}
			}
			returnAST = filter_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void and_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("and_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST and_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"and_expr",1,4809);
				equality_expr();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case KW_AND:
				{
					AST tmp186_AST = null;
					tmp186_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp186_AST);
					bShouldFire=aboutToEnter(bShouldFire,"and_expr",2,4819);
					match(KW_AND);
					bShouldFire=aboutToEnter(bShouldFire,"and_expr",3,4821);
					equality_expr();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case KW_OR:
				case RIGHT_PAREN:
				case RIGHT_BRACKET:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				and_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_61);
				} else {
				  throw ex;
				}
			}
			returnAST = and_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void equality_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("equality_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST equality_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"equality_expr",1,4868);
				relational_expr();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case EQUALS:
				case NOT_EQUALS:
				{
					{
					switch ( LA(1)) {
					case EQUALS:
					{
						AST tmp187_AST = null;
						tmp187_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp187_AST);
						bShouldFire=aboutToEnter(bShouldFire,"equality_expr",2,4883);
						match(EQUALS);
						break;
					}
					case NOT_EQUALS:
					{
						AST tmp188_AST = null;
						tmp188_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp188_AST);
						bShouldFire=aboutToEnter(bShouldFire,"equality_expr",3,4892);
						match(NOT_EQUALS);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					bShouldFire=aboutToEnter(bShouldFire,"equality_expr",4,4902);
					relational_expr();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case KW_OR:
				case KW_AND:
				case RIGHT_PAREN:
				case RIGHT_BRACKET:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				equality_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_62);
				} else {
				  throw ex;
				}
			}
			returnAST = equality_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void relational_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("relational_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST relational_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"relational_expr",1,4950);
				additive_expr();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case LT:
				case LTE:
				case GT:
				case GTE:
				{
					{
					switch ( LA(1)) {
					case LT:
					{
						AST tmp189_AST = null;
						tmp189_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp189_AST);
						bShouldFire=aboutToEnter(bShouldFire,"relational_expr",2,4967);
						match(LT);
						break;
					}
					case GT:
					{
						AST tmp190_AST = null;
						tmp190_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp190_AST);
						bShouldFire=aboutToEnter(bShouldFire,"relational_expr",3,4976);
						match(GT);
						break;
					}
					case LTE:
					{
						AST tmp191_AST = null;
						tmp191_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp191_AST);
						bShouldFire=aboutToEnter(bShouldFire,"relational_expr",4,4985);
						match(LTE);
						break;
					}
					case GTE:
					{
						AST tmp192_AST = null;
						tmp192_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp192_AST);
						bShouldFire=aboutToEnter(bShouldFire,"relational_expr",5,4994);
						match(GTE);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					bShouldFire=aboutToEnter(bShouldFire,"relational_expr",6,5004);
					additive_expr();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case KW_OR:
				case KW_AND:
				case RIGHT_PAREN:
				case RIGHT_BRACKET:
				case COMMA:
				case EQUALS:
				case NOT_EQUALS:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				relational_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_63);
				} else {
				  throw ex;
				}
			}
			returnAST = relational_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void additive_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("additive_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST additive_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"additive_expr",1,5054);
				mult_expr();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case PLUS:
				case MINUS:
				{
					{
					switch ( LA(1)) {
					case PLUS:
					{
						AST tmp193_AST = null;
						tmp193_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp193_AST);
						bShouldFire=aboutToEnter(bShouldFire,"additive_expr",2,5069);
						match(PLUS);
						break;
					}
					case MINUS:
					{
						AST tmp194_AST = null;
						tmp194_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp194_AST);
						bShouldFire=aboutToEnter(bShouldFire,"additive_expr",3,5078);
						match(MINUS);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					bShouldFire=aboutToEnter(bShouldFire,"additive_expr",4,5088);
					mult_expr();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case KW_OR:
				case KW_AND:
				case RIGHT_PAREN:
				case RIGHT_BRACKET:
				case COMMA:
				case EQUALS:
				case NOT_EQUALS:
				case LT:
				case LTE:
				case GT:
				case GTE:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				additive_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_64);
				} else {
				  throw ex;
				}
			}
			returnAST = additive_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void mult_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("mult_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST mult_expr_AST = null;
			
			try {      // for error handling
				bShouldFire=aboutToEnter(bShouldFire,"mult_expr",1,5142);
				unary_expr();
				astFactory.addASTChild(currentAST, returnAST);
				{
				switch ( LA(1)) {
				case STAR:
				case DIV:
				case MOD:
				{
					{
					switch ( LA(1)) {
					case STAR:
					{
						AST tmp195_AST = null;
						tmp195_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp195_AST);
						bShouldFire=aboutToEnter(bShouldFire,"mult_expr",2,5158);
						match(STAR);
						break;
					}
					case DIV:
					{
						AST tmp196_AST = null;
						tmp196_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp196_AST);
						bShouldFire=aboutToEnter(bShouldFire,"mult_expr",3,5167);
						match(DIV);
						break;
					}
					case MOD:
					{
						AST tmp197_AST = null;
						tmp197_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp197_AST);
						bShouldFire=aboutToEnter(bShouldFire,"mult_expr",4,5176);
						match(MOD);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					bShouldFire=aboutToEnter(bShouldFire,"mult_expr",5,5186);
					unary_expr();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case KW_OR:
				case KW_AND:
				case RIGHT_PAREN:
				case RIGHT_BRACKET:
				case COMMA:
				case PLUS:
				case MINUS:
				case EQUALS:
				case NOT_EQUALS:
				case LT:
				case LTE:
				case GT:
				case GTE:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				mult_expr_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_65);
				} else {
				  throw ex;
				}
			}
			returnAST = mult_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	public final void unary_expr() throws RecognitionException, TokenStreamException {
		
		boolean bShouldFire=false;
		if(_as_beginStep==true){
		_as_beginStep=false;  bShouldFire=true;
		}
		enterRule("unary_expr");
		try { // debugging
			returnAST = null;
			ASTPair currentAST = new ASTPair();
			AST unary_expr_AST = null;
			
			try {      // for error handling
				switch ( LA(1)) {
				case LITERAL:
				case NUMBER:
				case IDENTIFIER:
				case LEFT_PAREN:
				case DOT:
				case DOT_DOT:
				case AT:
				case SLASH:
				case DOUBLE_SLASH:
				case DOLLAR_SIGN:
				case STAR:
				{
					bShouldFire=aboutToEnter(bShouldFire,"unary_expr",1,5255);
					union_expr();
					astFactory.addASTChild(currentAST, returnAST);
					unary_expr_AST = (AST)currentAST.root;
					break;
				}
				case MINUS:
				{
					AST tmp198_AST = null;
					tmp198_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp198_AST);
					bShouldFire=aboutToEnter(bShouldFire,"unary_expr",2,5266);
					match(MINUS);
					bShouldFire=aboutToEnter(bShouldFire,"unary_expr",3,5268);
					unary_expr();
					astFactory.addASTChild(currentAST, returnAST);
					unary_expr_AST = (AST)currentAST.root;
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_66);
				} else {
				  throw ex;
				}
			}
			returnAST = unary_expr_AST;
		} finally { // debugging
			exitRule();
		}
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"if\"",
		"\"else\"",
		"\"elseif\"",
		"\"or\"",
		"\"and\"",
		"\"true\"",
		"\"false\"",
		"\"forall\"",
		"\"exists\"",
		"\"in\"",
		"\"let\"",
		"\"store\"",
		"\"retrieve\"",
		"\"Resp_Time\"",
		"\"max\"",
		"\"min\"",
		"\"avg\"",
		"\"sum\"",
		"\"product\"",
		"\"returnInt\"",
		"\"returnBool\"",
		"\"returnString\"",
		"WS",
		"DIGIT",
		"SINGLE_QUOTE_STRING",
		"DOUBLE_QUOTE_STRING",
		"LITERAL",
		"NUMBER",
		"IDENTIFIER",
		"SEMI",
		"LEFT_PAREN",
		"RIGHT_PAREN",
		"LEFT_BRACKET",
		"RIGHT_BRACKET",
		"LEFT_CURLY",
		"RIGHT_CURLY",
		"PIPE",
		"DOT",
		"DOT_DOT",
		"AT",
		"COMMA",
		"DOUBLE_COLON",
		"COLON",
		"SLASH",
		"DOUBLE_SLASH",
		"DOLLAR_SIGN",
		"PLUS",
		"MINUS",
		"PERCENTAGE",
		"DOUBLE_EQUALS",
		"EQUALS",
		"NOT_EQUALS",
		"LT",
		"LTE",
		"GT",
		"GTE",
		"STAR",
		"AND",
		"OR",
		"NOT",
		"KW_LR_IMPLIES",
		"KW_RL_IMPLIES",
		"KW_2WIMPLIES",
		"NEWLINE",
		"RECOVERY",
		"CONDITION",
		"COMPLETE",
		"STRATEGY",
		"IF",
		"ELSEIF",
		"ELSE",
		"ACTION",
		"STEP",
		"RULES",
		"EXTERNAL_VARIABLE",
		"INTERNAL_VARIABLE",
		"PARAM_LIST",
		"METHOD",
		"FORALL",
		"EXISTS",
		"SERIES",
		"CONCAT",
		"WSDL",
		"WM",
		"INPUTS",
		"OUTPUTS",
		"XPATH",
		"VAR",
		"LET",
		"STORE",
		"RETRIEVE",
		"MAX",
		"MIN",
		"AVG",
		"SUM",
		"PRODUCT",
		"RETURN_NUMBER",
		"RETURN_BOOL",
		"RETURN_STRING",
		"ALIAS",
		"ALIAS_NAME",
		"PROCESS_ID",
		"USER_ID",
		"INSTANCE_ID",
		"LOCATION",
		"ASSERTION_TYPE",
		"HISTORICAL_VARIABLE",
		"NUMBER_OF_RESULTS",
		"DIV",
		"MOD"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 562974708450816L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 34359738370L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 98L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 274877906944L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 549755813888L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 549755814016L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 549755814272L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 34359738368L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 563009068189186L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { 9204953082557700096L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { 9205250503666288514L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { 9204390111062523904L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { 9204953635526788994L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { 9204953910412828642L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { 9205250778552328162L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	private static final long[] mk_tokenSet_16() {
		long[] data = { 1160943541443100672L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
	private static final long[] mk_tokenSet_17() {
		long[] data = { 562967192076288L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
	private static final long[] mk_tokenSet_18() {
		long[] data = { 562971487043584L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_18 = new BitSet(mk_tokenSet_18());
	private static final long[] mk_tokenSet_19() {
		long[] data = { 1153922084942970880L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_19 = new BitSet(mk_tokenSet_19());
	private static final long[] mk_tokenSet_20() {
		long[] data = { 1157424132556652544L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_20 = new BitSet(mk_tokenSet_20());
	private static final long[] mk_tokenSet_21() {
		long[] data = { 9205249953910292480L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_21 = new BitSet(mk_tokenSet_21());
	private static final long[] mk_tokenSet_22() {
		long[] data = { 9205357225013659522L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_22 = new BitSet(mk_tokenSet_22());
	private static final long[] mk_tokenSet_23() {
		long[] data = { 562972560785408L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_23 = new BitSet(mk_tokenSet_23());
	private static final long[] mk_tokenSet_24() {
		long[] data = { 9204953082549567488L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_24 = new BitSet(mk_tokenSet_24());
	private static final long[] mk_tokenSet_25() {
		long[] data = { 9205357499899699170L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_25 = new BitSet(mk_tokenSet_25());
	private static final long[] mk_tokenSet_26() {
		long[] data = { 9204393409597407234L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_26 = new BitSet(mk_tokenSet_26());
	private static final long[] mk_tokenSet_27() {
		long[] data = { 9204954182061195266L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_27 = new BitSet(mk_tokenSet_27());
	private static final long[] mk_tokenSet_28() {
		long[] data = { 9205251603177916290L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_28 = new BitSet(mk_tokenSet_28());
	private static final long[] mk_tokenSet_29() {
		long[] data = { 9204391210574151682L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_29 = new BitSet(mk_tokenSet_29());
	private static final long[] mk_tokenSet_30() {
		long[] data = { 1153922084884185088L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_30 = new BitSet(mk_tokenSet_30());
	private static final long[] mk_tokenSet_31() {
		long[] data = { 9205356675198877698L, 7L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_31 = new BitSet(mk_tokenSet_31());
	private static final long[] mk_tokenSet_32() {
		long[] data = { 9223371623523141506L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_32 = new BitSet(mk_tokenSet_32());
	private static final long[] mk_tokenSet_33() {
		long[] data = { 9223372035848134626L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_33 = new BitSet(mk_tokenSet_33());
	private static final long[] mk_tokenSet_34() {
		long[] data = { 9223371898409181154L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_34 = new BitSet(mk_tokenSet_34());
	private static final long[] mk_tokenSet_35() {
		long[] data = { 1706463579930624L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_35 = new BitSet(mk_tokenSet_35());
	private static final long[] mk_tokenSet_36() {
		long[] data = { 1155065577035857920L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_36 = new BitSet(mk_tokenSet_36());
	private static final long[] mk_tokenSet_37() {
		long[] data = { 1156298198231285760L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_37 = new BitSet(mk_tokenSet_37());
	private static final long[] mk_tokenSet_38() {
		long[] data = { 2292331238595232128L, 844424930131968L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_38 = new BitSet(mk_tokenSet_38());
	private static final long[] mk_tokenSet_39() {
		long[] data = { 17179869184L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_39 = new BitSet(mk_tokenSet_39());
	private static final long[] mk_tokenSet_40() {
		long[] data = { 9223371211147313538L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_40 = new BitSet(mk_tokenSet_40());
	private static final long[] mk_tokenSet_41() {
		long[] data = { 9223371760962094978L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_41 = new BitSet(mk_tokenSet_41());
	private static final long[] mk_tokenSet_42() {
		long[] data = { 9222407945545843074L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_42 = new BitSet(mk_tokenSet_42());
	private static final long[] mk_tokenSet_43() {
		long[] data = { 1152936902064603136L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_43 = new BitSet(mk_tokenSet_43());
	private static final long[] mk_tokenSet_44() {
		long[] data = { 9222795063833133442L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_44 = new BitSet(mk_tokenSet_44());
	private static final long[] mk_tokenSet_45() {
		long[] data = { 9223336576590006146L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_45 = new BitSet(mk_tokenSet_45());
	private static final long[] mk_tokenSet_46() {
		long[] data = { 9223266207845828482L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_46 = new BitSet(mk_tokenSet_46());
	private static final long[] mk_tokenSet_47() {
		long[] data = { 9222759879461044610L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_47 = new BitSet(mk_tokenSet_47());
	private static final long[] mk_tokenSet_48() {
		long[] data = { 9222759875166077314L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_48 = new BitSet(mk_tokenSet_48());
	private static final long[] mk_tokenSet_49() {
		long[] data = { 9222759857986208130L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_49 = new BitSet(mk_tokenSet_49());
	private static final long[] mk_tokenSet_50() {
		long[] data = { 9222689489242030466L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_50 = new BitSet(mk_tokenSet_50());
	private static final long[] mk_tokenSet_51() {
		long[] data = { 9222689420522553730L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_51 = new BitSet(mk_tokenSet_51());
	private static final long[] mk_tokenSet_52() {
		long[] data = { 1152921508901814272L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_52 = new BitSet(mk_tokenSet_52());
	private static final long[] mk_tokenSet_53() {
		long[] data = { 137438953472L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_53 = new BitSet(mk_tokenSet_53());
	private static final long[] mk_tokenSet_54() {
		long[] data = { 17763984736256L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_54 = new BitSet(mk_tokenSet_54());
	private static final long[] mk_tokenSet_55() {
		long[] data = { 17626545782784L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_55 = new BitSet(mk_tokenSet_55());
	private static final long[] mk_tokenSet_56() {
		long[] data = { 1153359114529669120L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_56 = new BitSet(mk_tokenSet_56());
	private static final long[] mk_tokenSet_57() {
		long[] data = { 9222808257972666754L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_57 = new BitSet(mk_tokenSet_57());
	private static final long[] mk_tokenSet_58() {
		long[] data = { 562974649483264L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_58 = new BitSet(mk_tokenSet_58());
	private static final long[] mk_tokenSet_59() {
		long[] data = { 9223265658031047042L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_59 = new BitSet(mk_tokenSet_59());
	private static final long[] mk_tokenSet_60() {
		long[] data = { 9222421143980343682L, 844424930131975L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_60 = new BitSet(mk_tokenSet_60());
	private static final long[] mk_tokenSet_61() {
		long[] data = { 17763984736384L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_61 = new BitSet(mk_tokenSet_61());
	private static final long[] mk_tokenSet_62() {
		long[] data = { 17763984736640L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_62 = new BitSet(mk_tokenSet_62());
	private static final long[] mk_tokenSet_63() {
		long[] data = { 54060959513182592L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_63 = new BitSet(mk_tokenSet_63());
	private static final long[] mk_tokenSet_64() {
		long[] data = { 1134924870082101632L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_64 = new BitSet(mk_tokenSet_64());
	private static final long[] mk_tokenSet_65() {
		long[] data = { 1138302569802629504L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_65 = new BitSet(mk_tokenSet_65());
	private static final long[] mk_tokenSet_66() {
		long[] data = { 2291224074409476480L, 844424930131968L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_66 = new BitSet(mk_tokenSet_66());
	
	}
